package org.china.vo.das.engine.client;

import java.rmi.RemoteException;

import org.china.vo.das.engine.impl.*;
//import org.china.vo.das.engine.stubs.*;
//import org.china.vo.das.engine.stubs.bindings.*;
//import org.china.vo.das.engine.stubs.service.*;
import org.china.vo.das.engine.dASService.stubs.*;
import org.china.vo.das.engine.dASService.stubs.bindings.*;
import org.china.vo.das.engine.dASService.stubs.service.*;
import de.fb12.utils.beanutils.Beanutils;
import javax.xml.namespace.QName;
import javax.xml.rpc.ServiceException;

import org.apache.axis.message.MessageElement;
import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.china.vo.das.engine.dASService.stubs.AsynchQuery;
import org.china.vo.das.engine.dASService.stubs.CreateResource;
import org.china.vo.das.engine.dASService.stubs.CreateResourceResponse;
import org.china.vo.das.engine.dASService.stubs.DASFactoryPortType;
import org.china.vo.das.engine.dASService.stubs.DASPortType;
import org.china.vo.das.engine.dASService.stubs.GetAllResource;
import org.china.vo.das.engine.dASService.stubs.GetMetaColumns;
import org.china.vo.das.engine.dASService.stubs.GetMetaTables;
import org.china.vo.das.engine.dASService.stubs.Start;
import org.china.vo.das.engine.dASService.stubs.SynchQuery;
import org.china.vo.das.engine.dASService.stubs.service.DASFactoryServiceAddressingLocator;
import org.china.vo.das.engine.dASService.stubs.service.DASServiceAddressingLocator;
import org.china.vo.das.engine.impl.DASNamespaces;
import org.globus.axis.util.Util;
import org.oasis.wsrf.lifetime.Destroy;
import org.oasis.wsrf.properties.GetResourcePropertyResponse;
import org.oasis.wsrf.lifetime.ResourceNotDestroyedFaultType;
import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.List;


import org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType;
import org.oasis.wsrf.properties.ResourceUnknownFaultType;
import org.oasis.wsrf.properties.SetResourceProperties_Element;
import org.oasis.wsrf.properties.SetResourceProperties_PortType;
import org.oasis.wsrf.properties.UpdateType;
import org.oasis.wsrf.properties.WSResourcePropertiesServiceAddressingLocator;

public class DASClient implements DASNamespaces {

	static {
		Util.registerTransport();
	}

	private DASPortType port = null;

//	private String instanceURI = "http://159.226.169.49:8080/wsrf/services/DASService";
//
//	private String factoryURI = "http://159.226.169.49:8080/wsrf/services/DASFactoryService";
	
	String instanceURI = "http://192.168.3.3:8080/wsrf/services/DASService";
	String factoryURI = "http://192.168.3.3:8080/wsrf/services/DASFactoryService";

	private DASFactoryPortType factoryPort = null;

	private static EndpointReferenceType instanceEPR;

	public DASPortType getPort(String factoryURI, String instanceURI)
			throws MalformedURIException, ServiceException, RemoteException {
		DASFactoryServiceAddressingLocator factoryLocator = new DASFactoryServiceAddressingLocator();
		EndpointReferenceType factoryEPR;// , instanceEPR;
		DASServiceAddressingLocator locator = new DASServiceAddressingLocator();
		factoryEPR = new EndpointReferenceType();
		factoryEPR.setAddress(new Address(factoryURI));
		factoryPort = factoryLocator.getDASFactoryPortTypePort(factoryEPR);
		CreateResourceResponse createResponse = factoryPort
				.createResource(new CreateResource());
		instanceEPR = createResponse.getEndpointReference();
		instanceEPR.setAddress(new Address(instanceURI));
		DASPortType port = locator.getDASPortTypePort(instanceEPR);
		return port;
	}

	public DASClient(EndpointReferenceType instanceEPR) throws ServiceException {
		DASServiceAddressingLocator locator = new DASServiceAddressingLocator();
		this.port = locator.getDASPortTypePort(instanceEPR);
	}

	public DASClient(String factoryURI, String instanceURI)
			throws MalformedURIException, RemoteException, ServiceException {
		this.port = getPort(factoryURI, instanceURI);
		this.factoryURI = factoryURI;
		this.instanceURI = instanceURI;
	}

	/**
	 * 
	 * @generated
	 */
	public java.lang.String synchQuery(java.lang.String adql, int format)
			throws RemoteException  {
		
		java.lang.String retVal=  port.synchQuery(new SynchQuery(adql, format)).getSynchQueryReturn();
		return retVal;
	
	}
	
	
	/**
	 * 
	 * @generated
	 */
	public void AsynchQuery(java.lang.String adql, int format, java.lang.String targetURL) throws RemoteException  {
	 port.asynchQuery(new AsynchQuery(adql, format, targetURL));
	}
	
	
	/**
	 * 
	 * @generated
	 */
	public void start() throws RemoteException  {
	 port.start(new Start());
	}
	
	
	/**
	 * 
	 * @generated
	 */
	public java.lang.String getAllResource() throws RemoteException  {
		
		java.lang.String retVal=  port.getAllResource(new GetAllResource()).getGetAllResourceReturn();
		return retVal;
	
	}
	
	
	/**
	 * 
	 * @generated
	 */
	public java.lang.String getMetaTables(java.lang.String dataNodeName)
			throws RemoteException  {
		
		java.lang.String retVal=  port.getMetaTables(new GetMetaTables(dataNodeName)).getGetMetaTablesReturn();
		return retVal;
	
	}
	
	
	/**
	 * 
	 * @generated
	 */
	public java.lang.String getMetaColumns(java.lang.String dataNodeName, java.lang.String tableName) throws RemoteException  {
		
		java.lang.String retVal=  port.getMetaColumns(new GetMetaColumns(dataNodeName, tableName)).getGetMetaColumnsReturn();
		return retVal;
	
	}
	
	


  

	/**
	 * @generated
	 */
	public void destroy() throws ResourceNotDestroyedFaultType,
			org.oasis.wsrf.lifetime.ResourceUnknownFaultType, RemoteException {
			    port.destroy(new Destroy());
			  }
			  
	/**
	 * @generated
	 */
	public org.oasis.wsrf.lifetime.SetTerminationTimeResponse setTerminationTime(org.oasis.wsrf.lifetime.SetTerminationTime setTerminationTimeRequest)
			throws org.oasis.wsrf.lifetime.UnableToSetTerminationTimeFaultType,
			org.oasis.wsrf.lifetime.ResourceUnknownFaultType,
			org.oasis.wsrf.lifetime.TerminationTimeChangeRejectedFaultType,
			RemoteException
              {
                return port.setTerminationTime(setTerminationTimeRequest);
              }
			  
	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getResourceProperty(javax.xml.namespace.QName getResourcePropertyRequest)
			throws org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType,
			org.oasis.wsrf.properties.ResourceUnknownFaultType, RemoteException
              {
                return port.getResourceProperty(getResourcePropertyRequest);
              }
	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetMultipleResourcePropertiesResponse getMultipleResourceProperties(org.oasis.wsrf.properties.GetMultipleResourceProperties_Element getMultipleResourcePropertiesRequest)
			throws org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType,
			org.oasis.wsrf.properties.ResourceUnknownFaultType, RemoteException
              {
                return port.getMultipleResourceProperties(getMultipleResourcePropertiesRequest);
              }
			  
	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.SetResourcePropertiesResponse setResourceProperties(org.oasis.wsrf.properties.SetResourceProperties_Element setResourcePropertiesRequest)
			throws org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType,
			org.oasis.wsrf.properties.UnableToModifyResourcePropertyFaultType,
			org.oasis.wsrf.properties.ResourceUnknownFaultType,
			org.oasis.wsrf.properties.SetResourcePropertyRequestFailedFaultType,
			org.oasis.wsrf.properties.InvalidSetResourcePropertiesRequestContentFaultType,
			RemoteException
              {
                return port.setResourceProperties(setResourcePropertiesRequest);
              }
			  
	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.QueryResourcePropertiesResponse queryResourceProperties(org.oasis.wsrf.properties.QueryResourceProperties_Element queryResourcePropertiesRequest)
			throws org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType,
			org.oasis.wsrf.properties.InvalidQueryExpressionFaultType,
			org.oasis.wsrf.properties.QueryEvaluationErrorFaultType,
			org.oasis.wsrf.properties.ResourceUnknownFaultType,
			org.oasis.wsrf.properties.UnknownQueryExpressionDialectFaultType,
			RemoteException
              {
                return port.queryResourceProperties( queryResourcePropertiesRequest);
              }  
			  
	/**
	 * @generated
	 */
	public org.oasis.wsn.GetCurrentMessageResponse getCurrentMessage(org.oasis.wsn.GetCurrentMessage getCurrentMessageRequest)
			throws java.rmi.RemoteException,
			org.oasis.wsn.TopicNotSupportedFaultType,
			org.oasis.wsn.InvalidTopicExpressionFaultType,
			org.oasis.wsn.NoCurrentMessageOnTopicFaultType,
			org.oasis.wsn.ResourceUnknownFaultType
                {
                  return port.getCurrentMessage(getCurrentMessageRequest);
                }
			    
	/**
	 * @generated
	 */
	public org.oasis.wsn.SubscribeResponse subscribe(org.oasis.wsn.Subscribe subscribeRequest)
			throws java.rmi.RemoteException,
			org.oasis.wsn.TopicNotSupportedFaultType,
			org.oasis.wsn.InvalidTopicExpressionFaultType,
			org.oasis.wsn.SubscribeCreationFailedFaultType,
			org.oasis.wsn.ResourceUnknownFaultType,
			org.oasis.wsn.TopicPathDialectUnknownFaultType
                {
                  return port.subscribe(subscribeRequest);
                }
	/**
	 * @generated
	 */
	public org.oasis.wsn.PauseSubscriptionResponse pauseSubscription(org.oasis.wsn.PauseSubscription pauseSubscriptionRequest)
			throws java.rmi.RemoteException,
			org.oasis.wsn.PauseFailedFaultType,
			org.oasis.wsn.ResourceUnknownFaultType
                {
                  return port.pauseSubscription(pauseSubscriptionRequest);
                }
	/**
	 * @generated
	 */
	public org.oasis.wsn.ResumeSubscriptionResponse resumeSubscription(org.oasis.wsn.ResumeSubscription resumeSubscriptionRequest)
			throws java.rmi.RemoteException,
			org.oasis.wsn.ResumeFailedFaultType,
			org.oasis.wsn.ResourceUnknownFaultType
             	{
                  return port.resumeSubscription(resumeSubscriptionRequest);
                }

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getStatusAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_STATUS);
	}

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getExecplanAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_EXECPLAN);
	}

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getFormatAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_FORMAT);
	}

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getTargetURLAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_TARGETURL);
	}

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getQueryResultAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_QUERYRESULT);
	}

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getSubmitTimeAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_SUBMITTIME);
	}

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getStartTimeAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_STARTTIME);
	}

	/**
	 * @generated
	 */
	public org.oasis.wsrf.properties.GetResourcePropertyResponse getEndTimeAsResourceProperty() throws Exception, InvalidResourcePropertyQNameFaultType, ResourceUnknownFaultType, RemoteException {
    	return getResourceProperty(RP_ENDTIME);
	}

  
	/**
	 * This method updates resource property "rpQName" in the WS-Resource
	 * pointed at by the endpoint reference "epr" with the new value "Value".
	 * 
	 */

	// private void updateRP(EndpointReferenceType epr, QName rpQName, String
	// value)
	public static void updateRP(QName rpQName, String value)
	throws Exception{
	  /*Get a SetResourceProperties port type*/
	  WSResourcePropertiesServiceAddressingLocator locator = new WSResourcePropertiesServiceAddressingLocator();
	  SetResourceProperties_PortType port = locator.getSetResourcePropertiesPort(instanceEPR);
	  /*We will be invoking SetResourceProperties with a single Update*/
	  UpdateType update = new UpdateType();
	  MessageElement msg = new MessageElement(rpQName, value);
	  update.set_any(new MessageElement[] {msg});
	  
	  /*Create request object*/
	  SetResourceProperties_Element request = new SetResourceProperties_Element();
	  request.setUpdate(update);
	  
	  /*Invoking SetResourceProperties*/
	  port.setResourceProperties(request);
	  
}

	public static org.apache.axis.message.addressing.EndpointReferenceType getinstanceEPR() {
		return instanceEPR;
	}

	public static void main(String[] args) {
		String instanceURI = "http://192.168.3.3:8080/wsrf/services/DASService";
		String factoryURI = "http://192.168.3.3:8080/wsrf/services/DASFactoryService";
		//String str="select s.ra, s.decl from Archive:sppParams s where s.feha>-9 and s.feha<-3";
		String str="select s.ra, s.decl from SDSS:Star2 s where REGION('circle J2000 180 50 0.5')";
//		String str="select o.ra, o.decl,ss.ra,t.ra from DAItest:sdss o,SpecTest:DR6spSpecOrg ss,SDSS:Star2 t where ss.ra=t.ra and ss.ra=o.ra  and region('circle J2000 1 22 0.7') and o.decl>-9 and o.decl<-3";
		try {
			DASClient client = new DASClient(factoryURI, instanceURI);
			System.out.println("RPR:" + instanceEPR.toString());
//			client.AsynchQuery(str,2,"ftp://vodas:voftpdas@159.226.169.222/tiantest080515.csv");
			client.start();
//			updateRP(DASNamespaces.RP_STATUS, "FirstClient");
			// client.destroy();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
