package org.china.vo.das.engine.impl; 

import org.globus.wsrf.*;
import org.globus.wsrf.impl.*;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.xml.parsers.ParserConfigurationException;

import org.china.vo.das.engine.DAS;
import org.china.vo.das.service.ServerConfigure;
import org.globus.wsrf.Resource;
import org.globus.wsrf.ResourceIdentifier;
import org.globus.wsrf.ResourceLifetime;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourceProperty;
import org.globus.wsrf.ResourcePropertySet;
import org.globus.wsrf.impl.ReflectionResourceProperty;
import org.globus.wsrf.impl.SimpleResourcePropertyMetaData;
import org.globus.wsrf.impl.SimpleResourcePropertySet;
import org.xml.sax.SAXException;

public class DASResource implements 
	Resource, ResourceIdentifier, ResourceProperties, DASNamespaces, ResourceLifetime 
{
	private ResourcePropertySet propSet;
	private ResourceProperty statusRP;
	private ResourceProperty targetURLRP;
	private ResourceProperty queryResultRP;
	private ResourceProperty submitTimeRP;
	private Object key;
	private int jobvalidtime=6;
	
	/**
	 *
	 * @generated
	 */
	private ResourceProperty currTimeRP;
	/**
	 *
	 * @generated
	 */
	private ResourceProperty termTimeRP;
	/**
	 *
	 * @generated
	 */
	private Calendar terminationTime;
	 
	 
	
	/**
	 *
	 * @generated
	 */
	private DAS dAS;
	
	/**
	 *
	 * @generated
	 */
	public DAS getAnnotatedService() {
		return this.dAS;
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public java.lang.String getStatus() {
		// begin-user-code
		
		// end-user-code
		return dAS.getStatus();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setStatus(java.lang.String status) {
		this.dAS.setStatus(status);
		// begin-user-code
		
		// end-user-code
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public org.china.vo.das.service.ExecPlan getExecplan() {
		// begin-user-code
		
		// end-user-code
		return dAS.getExecplan();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setExecplan(org.china.vo.das.service.ExecPlan execplan) {
		this.dAS.setExecplan(execplan);
		// begin-user-code
		
		// end-user-code
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public int getFormat() {
		// begin-user-code
		
		// end-user-code
		return dAS.getFormat();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setFormat(int format) {
		this.dAS.setFormat(format);
		// begin-user-code
		
		// end-user-code
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public java.lang.String getTargetURL() {
		// begin-user-code
		
		// end-user-code
		return dAS.getTargetURL();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setTargetURL(java.lang.String targetURL) {
		this.dAS.setTargetURL(targetURL);
		// begin-user-code
		
		// end-user-code
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public java.lang.String getQueryResult() {
		// begin-user-code
		
		// end-user-code
		return dAS.getQueryResult();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setQueryResult(java.lang.String queryResult) {
		this.dAS.setQueryResult(queryResult);
		// begin-user-code
		
		// end-user-code
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public java.lang.String getSubmitTime() {
		// begin-user-code
		
		// end-user-code
		return dAS.getSubmitTime();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setSubmitTime(java.lang.String submitTime) {
		this.dAS.setSubmitTime(submitTime);
		// begin-user-code
		
		// end-user-code
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public java.lang.String getStartTime() {
		// begin-user-code
		
		// end-user-code
		return dAS.getStartTime();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setStartTime(java.lang.String startTime) {
		this.dAS.setStartTime(startTime);
		// begin-user-code
		
		// end-user-code
	}

	
	/**
	 *
	 * @modifiable-generated
	 */
	public java.lang.String getEndTime() {
		// begin-user-code
		
		// end-user-code
		return dAS.getEndTime();
	} 
	/**
	 *
	 * @modifiable-generated
	 */
	public void setEndTime(java.lang.String endTime) {
		this.dAS.setEndTime(endTime);
		// begin-user-code
		
		// end-user-code
	}

	

	/**
	 *
	 * @modifiable-generated
	 */
	public ResourcePropertySet getResourcePropertySet() {
		// begin-user-code
		
		// end-user-code
		return this.propSet;
	}

	/**
	 *
	 * @modifiable-generated
	 */
	public Object getID() {
		// begin-user-code
		
		// end-user-code
		return this.key;
	}

	/**
	 *
	 * @modifiable-generated
	 */
	public Object create() throws Exception {
		this.key = new Integer(hashCode());
		this.propSet = new SimpleResourcePropertySet(RESOURCE_PROPERTIES);
			
		this.dAS = new DAS();
	
//		initialize the WorkThread Number NUM
		ServerConfigure sc;
		sc = new ServerConfigure();
		String filepath = sc.getFilePath();
		try {
			sc.parseConfigureFile(filepath);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		jobvalidtime = Integer.parseInt(sc.getJobvalidperiod());
		
		try {
	
	
//	  this.propSet.add(new ReflectionResourceProperty(
//				RP_STATUS,"status",this));
	 
statusRP = new ReflectionResourceProperty(RP_STATUS,"status",this);
statusRP.add("PREPARING");
			
	  this.propSet.add(new ReflectionResourceProperty(
				RP_EXECPLAN,"execplan",this));
	 
	  this.propSet.add(new ReflectionResourceProperty(
				RP_FORMAT,"format",this));
	 
//	  this.propSet.add(new ReflectionResourceProperty(
//				RP_TARGETURL,"targetURL",this));
	  
	  targetURLRP = new ReflectionResourceProperty(RP_TARGETURL,"targetURL",this);
		targetURLRP.add("");
	 
//	  this.propSet.add(new ReflectionResourceProperty(
//				RP_QUERYRESULT,"queryResult",this));
	 
		queryResultRP = new ReflectionResourceProperty(RP_QUERYRESULT,"queryResult",this);
		queryResultRP.add("");
//	  this.propSet.add(new ReflectionResourceProperty(
//				RP_SUBMITTIME,"submitTime",this));
	  
	  SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	  submitTimeRP = new ReflectionResourceProperty(RP_SUBMITTIME,"submitTime",this);
	  submitTimeRP.add(formatter.format(new Date()));
	 
	  this.propSet.add(new ReflectionResourceProperty(
				RP_STARTTIME,"startTime",this));
	 
	  this.propSet.add(new ReflectionResourceProperty(
				RP_ENDTIME,"endTime",this));
	 
	 
	 
	
	
					
		termTimeRP = new ReflectionResourceProperty(
				SimpleResourcePropertyMetaData.TERMINATION_TIME, this);
		this.terminationTime = Calendar.getInstance();
		this.terminationTime.add(Calendar.DATE, jobvalidtime);
		this.propSet.add(termTimeRP);
					
		currTimeRP = new ReflectionResourceProperty(
				SimpleResourcePropertyMetaData.CURRENT_TIME, this);
		this.propSet.add(currTimeRP);
			
		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
		this.propSet.add(statusRP);
		this.propSet.add(targetURLRP);
		this.propSet.add(queryResultRP);
		this.propSet.add(submitTimeRP);
		return key;
	}
	
	
    
	
	public Calendar getCurrentTime() {
	return Calendar.getInstance();
	}
	/**
	 *
	 * @generated
	 */
	public Calendar getTerminationTime() {
		return this.terminationTime;
	}

	/**
	 *
	 * @generated
	 */
	public void setTerminationTime(Calendar terminationTime) {
		this.terminationTime=terminationTime;
	}
	
}
