package net.ivoa.adql;

import java.util.*;

import net.ivoa.adql.exceptions.TableItemNotFoundException;

public abstract class Function extends SelectItem implements SubExpression {
	String name;
	Vector parameters=null;
	int currIndex=0;
	public Function(){
		type=tp_function;
	}
	public String getADQLString(){
		String ret=(String)getValue();
		return ret;
	}
	public Object getValue(){
		String p="";
		ADQLToken op;
		int i=0;
		for(i=0;i<parameters.size()-1;i++){
			op=((Expression)(parameters.get(i))).getRoot();
			p+=op.getValue().toString()+", ";
		}
		op=((Expression)(parameters.get(i))).getRoot();
		p+=op.getValue().toString();
		return name+"("+p+")";
	}
	public void setName(String n){
		name=n;		
	}
	public void addParameter(Expression e){
		if(parameters==null){
			parameters=new Vector();
		}
		parameters.add(e);
	}
	public String getName(){
		return name;
	}
	public Expression getFirstParameter(){
		if(parameters!=null && parameters.size()>0){			
			currIndex=1;
			return (Expression)parameters.get(0);
		}
		else{
			return null;
		}
	}
	public Expression getNextParameter(){
		if(parameters!=null && parameters.size()>currIndex){
			return (Expression)parameters.get(currIndex++);
		}
		else{
			return null;
		}
	}/*
	public int containsTables(Vector tableAliasList)throws TableItemNotFoundException
	{
		int ret=3;
		return ret;
	}*/
	public void replaceAliasName(String oldname,String newname){
		Expression exp=getFirstParameter();
		while(exp!=null){
			replaceAliasNameForParam(exp,oldname,newname);
			exp=getNextParameter();
		}
	}
	public void replaceAliasNameForParam(Expression exp,String oldname,String newname){
		ADQLToken dbo=exp.getRoot();
		if(dbo!=null && dbo.getClassType()==ADQLToken.tp_dbobject){
			if(((DBObject)dbo).getSecond(0)!=null && ((DBObject)dbo).getFirst().getADQLString().equals(oldname) ){
				((DBObject)dbo).rename(newname);
			}
		}
		else if(dbo!=null && dbo.getClassType()==ADQLToken.tp_operator){
			((ADQLOperator)dbo).replaceAliasName(oldname,newname);
		}
		else if(dbo!=null && dbo.getClassType()==ADQLToken.tp_explicitfunction){
			((ExplicitFunction)dbo).replaceAliasName(oldname,newname);
		}
	}
	public Vector getDBObjectList(){
		Vector lsttot=new Vector();
		Expression exp=getFirstParameter();
		while(exp!=null){
			Vector lst=getDBObjectList0(exp);
			lsttot.addAll(lst);
			exp=getNextParameter();
		}
		return lsttot;
	}
	private Vector getDBObjectList0(Expression exp){
		Vector lst=new Vector();
		ADQLToken dbo=exp.getRoot();
		if(dbo!=null){
			if(dbo.getClassType()==ADQLToken.tp_operator){
				Vector lstLeft=((ADQLOperator)dbo).getDBObjectList();
				lst.addAll(lstLeft);
			}
			else if(dbo.getClassType()==ADQLToken.tp_dbobject){
				DBObject lft=(DBObject)dbo;
				if(lft.getSecond(0)!=null){
					lst.add(lft);
				}
				else{
					;
				}
			}
			else if(dbo.getClassType()==ADQLToken.tp_explicitfunction){
				Vector lstLeft=((ExplicitFunction)dbo).getDBObjectList();
				lst.addAll(lstLeft);
			}
		}
		return lst;
	}
}
