package net.ivoa.adql;

import java.util.Vector;

import net.ivoa.adql.exceptions.DBObjectNotFoundException;
import net.ivoa.adql.exceptions.TableItemNotFoundException;

public class Or  extends SearchCondition {
	public SearchCondition parent;
	public SearchCondition left;
	public SearchCondition right;
	public Or(){
		type=SearchCondition.TP_OR;
	}
	/**
	 * @return 1:only contains alias in tableAliasList
	 * 				2:contains other alias not in tableAliasList
	 * 				3:exception	
	 * 				0:not contains alias in tableAliasList
	 */
	public int containsTables(Vector tableAliasList)throws TableItemNotFoundException
	{
		int ret=0;
		if(left!=null){// && left.getType()==SearchCondition.TP_COMPAREOP){
			//ret=((CompareOp)left).containsTables(tableAliasList);
			ret=left.containsTables(tableAliasList);
		}/*
		else if(left!=null && (left.getType()==SearchCondition.TP_AND ||
				left.getType()==SearchCondition.TP_OR ||
				left.getType()==SearchCondition.TP_NOT)){
			ret=left.containsTables(tableAliasList);
		}
		else{
			;
		}*/
		int ret2=0;
		if(right!=null){// && right.getType()==SearchCondition.TP_COMPAREOP){
			//ret2=((CompareOp)right).containsTables(tableAliasList);
			ret2=right.containsTables(tableAliasList);
		}/*
		else if(right!=null && (right.getType()==SearchCondition.TP_AND ||
				right.getType()==SearchCondition.TP_OR ||
				right.getType()==SearchCondition.TP_NOT)){
			ret2=right.containsTables(tableAliasList);
		}
		else if(right.getType()==SearchCondition.TP_XMATCH){
			ret2
		}
		else{
			;
		}*/
		if(ret==ret2){
			;
		}
		else if(ret==3 || ret2==3){
			ret=3;
		}
		else if((ret==2 || ret2==2) && (ret!=3 && ret2!=3)){
			ret=2;
		}
		else{
			ret=2;
		}
		return ret;
	}
	/**
	 * listup all DBObjects contains in the columns and return as a Vector object
	 * @return
	 * @throws DBObjectNotFoundException
	 */
	private Vector getAllDBObjects0()throws DBObjectNotFoundException{
		Vector ret=new Vector();
		if(left!=null){
			DBObject[] dbs=left.getAllDBObjects();
			if(dbs!=null){
				for(int i=0;i<dbs.length;i++){
					ret.add(dbs[i]);
				}
			}
		}
		if(right!=null){
			DBObject[] dbs=right.getAllDBObjects();
			if(dbs!=null){
				for(int i=0;i<dbs.length;i++){
					ret.add(dbs[i]);
				}
			}
		}
		return ret;
	}
	/**
	 * list up all DBObjects contain in the Column and return as an array
	 */
	public DBObject[] getAllDBObjects()throws DBObjectNotFoundException{
		DBObject[] ret=null;
		Vector ret0=getAllDBObjects0();
		if(ret0!=null && ret0.size()>0){
			ret=new DBObject[ret0.size()];
			for(int i=0;i<ret0.size();i++){
				ret[i]=(DBObject)ret0.get(i);
			}
		}
		return ret;
	}
	/**
	 * Query all DBObjects which are not contained in vector currDNTableAlias
	 * @return an array of DBObjects
	 */
	public DBObject[] getAllDBObjectsWithoutCurrDN(Vector currDNTableAlias)throws TableItemNotFoundException, DBObjectNotFoundException
	{
		DBObject[] ret=null;
		Vector ret0=getAllDBObjects0();
		if(ret0!=null){
			for(int i=0;i<ret0.size();i++){
				String o=((DBObject)ret0.get(i)).getFirst().getADQLString();
				for(int j=0;j<currDNTableAlias.size();j++){
					String a=((DBObject)currDNTableAlias.get(j)).getFirst().getADQLString();
					if(a.equals(o)){
						ret0.remove(i);
						break;
					}
				}
			}
			ret=new DBObject[ret0.size()];
			for(int i=0;i<ret.length;i++){
				ret[i]=(DBObject)ret0.get(i);
			}
		}
		return ret;
	}
	/**
	 * get the column's name string, can be used in SQL query string
	 * @return 
	 */
	public String getADQLString(){
		String ret="";
		ret+=left.getADQLString();
		ret+=" OR "+right.getADQLString();
		return ret;
	}
	/**
	 * using newname to take place the oldname forall DBObjects containsin the column
	 * @param oldname
	 * @param newname
	 */
	public void replaceName(String oldname, String newname){
		if(left!=null){
			left.replaceName(oldname,newname);
		}
		if(right!=null){
			right.replaceName(oldname,newname);
		}
	}
	public void setLeft(SearchCondition sc){
		left=sc;
	}
	public void setRight(SearchCondition sc){
		right=sc;
	}
	public SearchCondition getLeft(){
		return left;
	}
	public SearchCondition getRight(){
		return right;
	}
	public SearchCondition getParent(){
		return parent;
	}
	public void setParent(SearchCondition sc){
		parent=sc;
	}
}
