package net.ivoa.adql;

import java.util.Vector;

import net.ivoa.adql.exceptions.DBObjectNotFoundException;
import net.ivoa.adql.exceptions.TableItemNotFoundException;

public class Region  extends SearchCondition {
	static public final int TP_CIRCLE=0;
	static public final int EPOCH_FK5=2000;
	public String regstring="";
	public int regtype=0;
	public int epoch=EPOCH_FK5;
	public double[] regparams=null;
	
	private void setEpoch(String e){
		if(e.equalsIgnoreCase("J2000")){
			epoch=EPOCH_FK5;
		}
	}
	public Region(Function f){
		type=SearchCondition.TP_REGION;
		Expression ex=f.getFirstParameter();
		regstring=ex.getRoot().getValue().toString();
		regstring=regstring.substring(1,regstring.length()-1);
		String[] reg=regstring.split(" ");
		if(reg[0].equalsIgnoreCase("circle")){
			regtype=TP_CIRCLE;
			setEpoch(reg[1]);
			regparams=new double[3];			
			for(int i=2;i<5;i++){
				if(i<reg.length){
					try{
						regparams[i-2]=Double.parseDouble(reg[i]);
					}
					catch(Exception e){
						regparams[i-2]=0.0;
					}
				}
				else{
					regparams[i-2]=0.0;
				}
			}
		}
	}
	/**
	 * @return 1:only contains alias in tableAliasList
	 * 				2:contains other alias not in tableAliasList
	 * 				3:exception	
	 * 				0:not contains alias in tableAliasList
	 * 1:|--------| * |-------| * |--------|   *  |------|   *  |-------|
	 * 2:|--------| * |-----|   * |----------| *   |-------| *           |---|
	 * r:   1      *    2           1              2            0    
	 */
	public int containsTables(Vector tableAliasList)throws TableItemNotFoundException{
		int ret=0;
		return ret;
	}
	/**
	 * get the column's name string, can be used in SQL query string
	 * @return 
	 */
	public String getADQLString(){
		String ret=" REGION(' "+regstring+"') ";
		return ret;
	}
	/**
	 * using newname to take place the oldname forall DBObjects containsin the column
	 * @param oldname
	 * @param newname
	 */
	public void replaceName(String oldname, String newname){
		
	}
	public DBObject[] getAllDBObjects()throws DBObjectNotFoundException{
		return null;
	}
	public DBObject[] getAllDBObjectsWithoutCurrDN(Vector currDNTableAlias)throws TableItemNotFoundException{
		return null;
	}
	int getEpoch(){
		return epoch;
	}
	int getRegionType(){
		return regtype;
	}
	double[] getParameters(){
		return regparams;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
