package net.ivoa.adql;

import java.util.Vector;

import net.ivoa.adql.exceptions.DBObjectNotFoundException;
import net.ivoa.adql.exceptions.TableItemNotFoundException;

public class XMatch  extends SearchCondition {
	Vector xaliaslist=new Vector();
	double xsigma;
	//boolean bLessthan;
	public XMatch(){
		type=SearchCondition.TP_XMATCH;
	}
	public XMatch(Function f){
		type=SearchCondition.TP_XMATCH;
		Expression ex=f.getFirstParameter();
		String p=ex.getRoot().getValue().toString();		
		try{
			Double.parseDouble(p);
			//error
			throw new Exception();
		}
		catch(Exception e){
			xaliaslist.add(p);
		}
		while((ex=f.getNextParameter())!=null){
			try{
				 p=ex.getRoot().getValue().toString();		
				xsigma=Double.parseDouble(p);
				if(xaliaslist.size()<2){//error
					throw new Exception();
				}
				else{
					break;
				}
			}
			catch(Exception e){
				xaliaslist.add(p);
			}			
		}		
	}
	/**
	 * @return 1:only contains alias in tableAliasList
	 * 				2:contains other alias not in tableAliasList
	 * 				3:exception	
	 * 				0:not contains alias in tableAliasList
	 * 1:|--------| * |-------| * |--------|   *  |------|   *  |-------|
	 * 2:|--------| * |-----|   * |----------| *   |-------| *           |---|
	 * r:   1      *    2           1              2            0    
	 */
	public int containsTables(Vector tableAliasList)throws TableItemNotFoundException{
		int ret=0;
		
		if(xaliaslist!=null){
			for(int i=0;i<xaliaslist.size();i++){
				String p=(String)xaliaslist.get(i);
				for(int j=0;j<tableAliasList.size();j++){					
					DBObject dbo=(DBObject)tableAliasList.get(j);
					String q=dbo.getADQLString();
					if(p.equalsIgnoreCase(q)){
						ret++;
					}				
					else{
						//f=true;
					}
					
				}
				
			}
			if(ret==xaliaslist.size()){
				ret=1;
			}
			else if(ret==0){
				ret=0;
			}
			else{
				ret=2;
			}
		}
		return ret;
	}
	/**
	 * get the column's name string, can be used in SQL query string
	 * @return 
	 */
	public String getADQLString(){
		String ret=" XMATCH( ";
		if(xaliaslist!=null){
			for(int i=0;i<xaliaslist.size();i++){
				ret+=(String)(xaliaslist.get(i))+", ";
			}
		}
		ret+=xsigma+") ";
		return ret;
	}
	/**
	 * using newname to take place the oldname forall DBObjects containsin the column
	 * @param oldname
	 * @param newname
	 */
	public void replaceName(String oldname, String newname){
		Vector x2=new Vector();
		if(xaliaslist!=null){
			for(int i=0;i<xaliaslist.size();i++){
				String p=(String)xaliaslist.get(i);
				if(p.equalsIgnoreCase(oldname)){
					x2.add(newname);
				}
				else{
					x2.add(p);
				}
			}
		}
		xaliaslist.removeAllElements();
		xaliaslist=x2;
	}
	public DBObject[] getAllDBObjects()throws DBObjectNotFoundException{
		return null;
	}
	public DBObject[] getAllDBObjectsWithoutCurrDN(Vector currDNTableAlias)throws TableItemNotFoundException{
		return null;
	}
	public Vector getXAliasList(){
		return xaliaslist;
	}
	public double getSigma(){
		return xsigma;
	}
	public void setXAliasList(Vector x){
		xaliaslist=x;
	}
	public void setSigma(double x){
		 xsigma=x;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
