package org.china.vo.das.datanode;

//import uk.org.ogsadai.activity.ActivityRequest;
import java.net.MalformedURLException;
import java.util.Vector;

import org.china.vo.das.exceptions.CheckDNColumnsException;
import org.china.vo.das.exceptions.CheckDNTableException;
import org.china.vo.das.exceptions.DataNodePerformException;
import org.china.vo.das.exceptions.GetTableTypeException;
import org.china.vo.das.registry.MDDataResource;

import uk.org.ogsadai.client.toolkit.GenericServiceFetcher;
import uk.org.ogsadai.client.toolkit.Response;
import uk.org.ogsadai.client.toolkit.activity.ActivityRequest;
import uk.org.ogsadai.client.toolkit.exception.AuthorisationException;
import uk.org.ogsadai.client.toolkit.exception.RequestException;
import uk.org.ogsadai.client.toolkit.exception.ResourceBusyException;
import uk.org.ogsadai.client.toolkit.exception.ResourceUnknownException;
import uk.org.ogsadai.client.toolkit.exception.ServerException;
import uk.org.ogsadai.client.toolkit.exception.ServiceCommsException;
import uk.org.ogsadai.client.toolkit.service.DataService;
//import uk.org.ogsadai.client.toolkit.sessions.Session;

public class DataResource {


	private MDDataResource drMDDataResource;


	public Response perform(ActivityRequest ar) throws DataNodePerformException,ServiceCommsException,MalformedURLException,ServerException,ResourceUnknownException,AuthorisationException,ResourceBusyException,RequestException{
		String handle = getDRurl();
//		String handle = "http://192.168.3.150:8080/wsrf/services/ogsadai/DataService";
		String id = getDRname();
//		String id = "BADCDAITEST";
		DataService service = GenericServiceFetcher.getInstance().getDataService(handle, id);
//		System.out.println("hello");
		Response response = service.perform( ar );
		//Session session = response.getSession();
		System.out.println(response.getAsString());
		return response;

		}
	public void setDrMDDataResource(MDDataResource drMDDataResource) {
		this.drMDDataResource = drMDDataResource;

	}

	public MDDataResource getDrMDDataResource() {
		return drMDDataResource;
	}




	public int getTableType() throws GetTableTypeException{
		/*added by LC 2008-05-07*/
		String dntype= drMDDataResource.getDNType();
		int ntype=1;//default is catalog
		if(dntype.equalsIgnoreCase("spectra")){
			ntype=3;//spectroscopy data
		}
		return ntype;
	}

	public String getDRurl(){
		return drMDDataResource.getService().getInterfaces().getInterfaceURL();
	}


	public String getDRname(){
			return drMDDataResource.getIdentity().getTitle();
	}
	
	public boolean checkDNTable(String TableName) throws CheckDNTableException {
		return drMDDataResource.hasTable(TableName);
	}

	public boolean checkDNColumns(String TableName, Vector ColumnName)
	throws CheckDNColumnsException, CheckDNTableException {
boolean hascol=true;
for(int i=0;i<ColumnName.size();i++)
{


if(!drMDDataResource.hasColumn(TableName, (String)ColumnName.get(i)))
	hascol=false;
}
return hascol;
}

	
	public String getMDDataResourceString(){
		return drMDDataResource.getXmlString();
	}	
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}