package org.china.vo.das.datanode;

import java.util.*;

import org.china.vo.das.exceptions.ExceptionMessage;
import org.china.vo.das.registry.*;

public class DataResourceMap {

	private static DataResourceMap instance = null;

	public HashMap dataResourceMap = new HashMap();

	/**
	 * 
	 * 
	 */
	private DataResourceMap() {

	}

	public synchronized static DataResourceMap getInstance() {
		if (instance == null) {
			instance = new DataResourceMap();
		}
		return instance;

	}

	/**
	 * 
	 * @return
	 */
	public String getAllResource() {
		String dataResourceName = null;
		DataResource dataResource = null;
		MDDataResource mdDataResource = null;
		String allresourceXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> <ArrayOfDBResource xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns=\"http://www.us-vo.org\">";
		Set set = dataResourceMap.keySet();
		Iterator it = set.iterator();
		while (it.hasNext()) {
			dataResourceName = (String) it.next();
			allresourceXML += "<DBResource><Title>" + dataResourceName;
			dataResource = (DataResource) dataResourceMap
					.get((Object) dataResourceName);
			mdDataResource = dataResource.getDrMDDataResource();
			allresourceXML += "</Title><Type>"
					+ mdDataResource.getDNType();
			allresourceXML += "</Type><Description>"
					+ mdDataResource.getGeneralcontent().getDescription();
			allresourceXML += "</Description></DBResource>";
		}
		allresourceXML += "</ArrayOfDBResource>";
		return allresourceXML;
	}

	public String getMetaTables(String dataResourceName) {
		DataResource dataResource = null;
		MDDataResource mdDataResource = null;
		ArrayList alist = null;
		MDTable mdTable = null;
		String metaTablesXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> <ArrayOfTables xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns=\"http://www.us-vo.org\">";
		dataResource = (DataResource) dataResourceMap
				.get((Object) dataResourceName);
		mdDataResource = dataResource.getDrMDDataResource();
		alist = mdDataResource.getTables();
		Iterator it = alist.iterator();
		while (it.hasNext()) {
			mdTable = (MDTable) it.next();
			metaTablesXML += "<Table><Name>" + mdTable.getName();
			metaTablesXML += "</Name><Description>" + mdTable.getDescription();
			metaTablesXML += "</Description><ColumnsNum>"
					+ mdTable.getColumnsNum();
			metaTablesXML += "</ColumnsNum></Table>";
		}
		metaTablesXML += "</ArrayOfTables>";

		return metaTablesXML;
	}

	public String getMetaColomns(String dataResourceName, String tableName) {
		DataResource dataResource = null;
		MDDataResource mdDataResource = null;
		ArrayList tablelist = null;
		MDTable mdTable = null;
		MDField mdField = null;
		ArrayList columnlist = null;
		String metaColumnsXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> <ArrayOfColumns xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns=\"http://www.us-vo.org\">";
		dataResource = (DataResource) dataResourceMap
				.get((Object) dataResourceName);
		mdDataResource = dataResource.getDrMDDataResource();
		tablelist = mdDataResource.getTables();
		Iterator it = tablelist.iterator();

		while (it.hasNext()) {
			mdTable = (MDTable) it.next();
			if ((mdTable.getName()).equals(tableName)) {
				columnlist = mdTable.getColumns();
				Iterator itcolumn = columnlist.iterator();
				while (itcolumn.hasNext()) {
					mdField = (MDField) itcolumn.next();
					metaColumnsXML += "<Column><Name>" + mdField.getname();
					metaColumnsXML += "</Name><DataType>"
							+ mdField.getdatatype();
					metaColumnsXML += "</DataType><UCD>" + mdField.getucd();
					metaColumnsXML += "</UCD><UNIT>" + mdField.getunit();
					metaColumnsXML += "</UNIT><Description>"
							+ mdField.getdescription();
					metaColumnsXML += "</Description></Column>";
				}
			}
		}
		metaColumnsXML += "</ArrayOfColumns>";

		return metaColumnsXML;
	}
	

	public static void main(String[] args){
		
		DataResourceMap drm;
		drm = DataResourceMap.getInstance();
		RegistryProxy rp = new RegistryProxy();
		try{
			rp.discover(drm);
		}catch(Exception e){
			//daslog.error(ExceptionMessage.DataNodeNotFoundException);
		}	
	}
}