package org.china.vo.das.engine;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;

import javax.xml.parsers.ParserConfigurationException;

import org.china.vo.das.datanode.DataResourceMap;
import org.china.vo.das.engine.impl.DASResource;
import org.china.vo.das.exceptions.ExceptionMessage;
import org.china.vo.das.log.DASLog;
import org.china.vo.das.registry.RegistryProxy;
import org.china.vo.das.service.ServerConfigure;
import org.xml.sax.SAXException;
//import org.globus.wsrf.ResourceKey;

import com.sun.jmx.snmp.Timestamp;

public class LoopThread implements Runnable {
	
	private static LoopThread instanceLT = null;

	private int NUM = 8;

	DASLog daslog;

	DataResourceMap drm;

	WaitingQueue instance;

	private int waitingNum;

	private int workthreadNum;

	private DASResource session = null;

	private String status = null;

	long nowtime = 0;

	long submittime = 0;
	
	int sessionIdlePeriod = 120000;
	
	int discoverPeriod = 6000000;
	
	long discovertime = 0;

	boolean flag_s = true;

	boolean flag_a = true;

	Iterator it;

	Iterator it_s;

	WorkThreadPool instancepool;

	SimpleDateFormat format = null;

	private LoopThread() {
		drm = DataResourceMap.getInstance();
		instance = WaitingQueue.getInstance();
		instancepool = WorkThreadPool.getInstance();
		daslog = new DASLog();
		format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		
		//initialize the WorkThread Number NUM
		ServerConfigure sc;
		sc = new ServerConfigure();
		String filepath = sc.getFilePath();
		try {
			sc.parseConfigureFile(filepath);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		NUM = Integer.parseInt(sc.getWorkthreadnum());
		sessionIdlePeriod = Integer.parseInt(sc.getSessionidleperiod());
		discoverPeriod = Integer.parseInt(sc.getDiscoverperiod());
	}
	
	public synchronized static LoopThread getInstance(){
		if(instanceLT == null){
			instanceLT = new LoopThread();
		}
		return instanceLT;
	}

	public void run() {
		RegistryProxy rp = new RegistryProxy();
		try {
			rp.discover(drm);
			instance.getWaitingQueue().clear();
			System.out.println("The WaitingQueue Has Been Cleared");
			discovertime = new Date().getTime();
		} catch (Exception e) {
			daslog.error(ExceptionMessage.DataNodeNotFoundException);
		}
		while (true) {
			workthreadNum = instancepool.getWorkTheadNum();
			LinkedList linkedListTMP = new LinkedList(instance.getWaitingQueue()); // AsyQuery List
			LinkedList linkedListTMP_S = new LinkedList(instance.getWaitingQueue()); // SyQuery List
			it = linkedListTMP.iterator();
			it_s = linkedListTMP_S.iterator();
			waitingNum = instance.getWaitingQueue().size();
			nowtime = new Date().getTime();

			System.out.println("Now WaitingNum is =====================:"+ waitingNum);
			System.out.println("Now WorkThreadNum is =====================:"+ workthreadNum);
						
			/*
			 * SynQuery, SynQuery is First, and there are more than 3 working
			 * threads only for SynQuery Must dispatch one (only) WorkThread in
			 * each loop
			 */
			
			flag_s=true;
			while (waitingNum > 0 && workthreadNum < NUM && it_s.hasNext()&& flag_s == true) {
				
				session = (DASResource) it_s.next();
				status = session.getStatus();
				System.out.println("Session ("+ session.getID().toString()+ "), Status is==========" +session.getStatus());

				if (status.toLowerCase().equals("preparing")) {

					try {
						submittime = format.parse(session.getSubmitTime()).getTime();
					} catch (ParseException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

					if ((nowtime - submittime) > sessionIdlePeriod) {
						instance.getWaitingQueue().remove(session);
						it_s.remove();
					} else if (it_s.hasNext()) {
						session = (DASResource) it_s.next();
					}
				}
				if (status.equals("FirstClient")) {
					instance.getWaitingQueue().remove(session);
					it_s.remove();
					System.out.println("Session ("+ session.getID().toString()+ "), FirstClient, Has Been Delete From WaitingQueue!");
				}
				
				if (status.equals("Error")) {
					instance.getWaitingQueue().remove(session);
					it_s.remove();
					System.out.println("Session ("+ session.getID().toString()+ "), Error, Has Been Delete From WaitingQueue!");
				}
				
				if ((status.toLowerCase().equals("waiting"))&& session.getTargetURL().equals("")) { // judge the syc by the condition of targeturl=""
					WorkThread workthread = new WorkThread(session);
					session.setStatus("PROCESSING");
					session.setStartTime(format.format(new Date()));
					workthread.setWorkThreadID(workthreadNum);
					workthread.start();
					instancepool.selfAdd();
					flag_s = false;
				}
			}

			
			/*
			 * AsynQuery, Must dispatch one (only) WorkThread in each loop
			 */
			
			flag_a=true;
			while (waitingNum > 0 && workthreadNum < NUM - 3 && it.hasNext()
					&& flag_a == true) {
				session = (DASResource) it.next();
				status = session.getStatus();

				if (status.toLowerCase().equals("preparing")) {

					try {
						submittime = format.parse(session.getSubmitTime())
								.getTime();
					} catch (ParseException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

					if ((nowtime - submittime) > sessionIdlePeriod) {
						// instance.getWaitingQueue().remove(session);
						it.remove();
					} else if (it.hasNext()) {
						session = (DASResource) it.next();
					}
				}
				if (status.equals("FirstClient")) {
					it.remove();
				}
				
				if (status.equals("Error")) {
					it.remove();
				}

				if ((status.toLowerCase().equals("waiting"))&& !(session.getTargetURL().equals(""))) {
					WorkThread workthread = new WorkThread(session);
					session.setStatus("PROCESSING");
					session.setStartTime(format.format(new Date()));
					workthread.setWorkThreadID(workthreadNum);
					workthread.start();
					instancepool.selfAdd();
					flag_a = false;
				}
			}
			
			/*
			 * re-discover every 100 minutes
			 * 
			 * NOTE: no safty here
			 */
			if((nowtime - discovertime)> discoverPeriod){
				
				discovertime = nowtime;
				try {
					rp.discover(drm);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
			try {
				Thread.sleep(8000);
			} catch (Exception e) {
				e.getMessage();
			}

		}

	}

}
