package org.china.vo.das.engine;

//import java.net.MalformedURLException;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.china.vo.das.engine.impl.DASResource;
import org.china.vo.das.service.ExecPlan;
import org.globus.wsrf.ResourceKey;

import com.sun.jmx.snmp.Timestamp;

import uk.org.ogsadai.client.toolkit.exception.AuthorisationException;
import uk.org.ogsadai.client.toolkit.exception.DataFormatException;
import uk.org.ogsadai.client.toolkit.exception.ResourceUnknownException;
import uk.org.ogsadai.client.toolkit.exception.ServerException;
import uk.org.ogsadai.client.toolkit.exception.ServiceCommsException;
import uk.org.ogsadai.client.toolkit.properties.RequestStatus;
import uk.org.ogsadai.client.toolkit.properties.UnknownPropertyException;
import uk.org.ogsadai.client.toolkit.sessions.Session;
//import org.globus.wsrf.NoSuchResourceException;
//import org.globus.wsrf.utils.FaultHelper;
//import org.oasis.wsrf.lifetime.ResourceUnknownFaultType;
//import org.oasis.wsrf.lifetime.ResourceNotDestroyedFaultType;

public class WorkThread extends Thread{
	
	private ExecPlan execplan = null;
	private DASResource sessionTMP = null;
	//private Object sessionKey = null;
	private Session ogsadaiSession = null;
	//ResourceContext ctx = null;
	//DASResourceHome home = null;
	WaitingQueue instance = WaitingQueue.getInstance();
	WorkThreadPool instancepool = WorkThreadPool.getInstance();
	int dnnum = 0;
	private int workThreadID;
	SimpleDateFormat formatter=null;
	

	/**
	 * @return Returns the workThreadID.
	 */
	public int getWorkThreadID() {
		return workThreadID;
	}
	/**
	 * @param workThreadID The workThreadID to set.
	 */
	public void setWorkThreadID(int workThreadID) {
		this.workThreadID = workThreadID;
	}
	
	public WorkThread(DASResource session){
		this.sessionTMP = session;
		execplan = session.getExecplan();
		execplan.setTargetURL(session.getTargetURL());
		execplan.setFormat(session.getFormat());
		dnnum = execplan.getARDNCount();
		//remove waitingQueue
		instance.getWaitingQueue().remove(session);
		formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//		System.out.println("waitingQueue's size is :" + instance.waitingQueue.size() );
	}
	
	public void run(){
		for(int i=0; i<dnnum; i++){
			try{
				execplan.runNextDN(i);
			}catch(Exception dpe){
				sessionTMP.setStatus("Error");
				dpe.printStackTrace();
			}
			//System.out.println("dnnum is :" + dnnum);
		}
		RequestStatus statusTMP;
			this.ogsadaiSession = execplan.getSession();
			try {
				statusTMP = this.ogsadaiSession.getStatus();
				//get status from OGSA-DAI
				while(statusTMP.equals(statusTMP.UNSTARTED) || statusTMP.equals(statusTMP.INITIALISING)|| statusTMP.equals(statusTMP.PROCESSING)){
					statusTMP = this.ogsadaiSession.getStatus();
					sessionTMP.setStatus(statusTMP.toString());
					System.out.println("Session ("+ sessionTMP.getID().toString()+ "), Status is==================:" +statusTMP.toString());
					Thread.sleep(8000);					
				}
				sessionTMP.setStatus(statusTMP.toString());
			} catch (UnknownPropertyException e1) {
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setQueryResult(execplan.getQueryResult());
				sessionTMP.setStatus("COMPLETED");
				System.out.println("Session ("+ sessionTMP.getID().toString()+ "), Status is==================:COMPLETED");
				//e1.printStackTrace();
			} catch (ServiceCommsException e1) {
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setStatus("Error");
				e1.printStackTrace();
			} catch (ResourceUnknownException e1) {
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setStatus("Error");
				e1.printStackTrace();
			} catch (ServerException e1) {
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setStatus("Error");
				e1.printStackTrace();
			} catch (DataFormatException e1) {
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setStatus("Error");
				e1.printStackTrace();
			} catch (AuthorisationException e1) {
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setStatus("Error");
				e1.printStackTrace();
			}catch (InterruptedException e) {
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setStatus("Error");
				e.printStackTrace();
			}catch(Exception e){
				sessionTMP.setEndTime(formatter.format(new Date()));
				sessionTMP.setStatus("Error");
				e.printStackTrace();
			}
		
//			System.out.println("Now WorkThread: "+ workThreadID +"=======which is clear ========================== !");
			
			instancepool.selfSubtract();

	}
}