package org.china.vo.das.exceptions;

public class ExceptionMessage {
	static final public int  Com_GeneralError=0x00000000;
	static final public int  Com_ConnectError=0x00000001;
	
	
	/**
	 * you can add your error message number at here
	 */
	/**
	 * Engine error message
	 */
	static final public int Eng_Error=0x00010000;
	
	/**
	 * Parser error message
	 */
	static final public int Par_Error=0x00020000;
	static final public int Par_syntaxError=0x00020001;
	static final public int Par_exprError=0x00020002;
	
	/**
	 * ExecutionPlan message
	 */
	static final public int ExP_Error=0x00030000;
	static final public int ExP_synatxError=0x00030001;
	static final public int DataNodeNotFoundException=0x00030002;
	static final public int GetTableTypeException=0x00030003;
	static final public int CheckDNTableException=0x00030004;
	static final public int CheckDNColumnsException=0x00030005;
	static final public int TableNotFound_Error=0x00030006;
	static final public int ColumnsNotFound_Error=0x00030007;
	static final public int TableTypeNotOne_Error=0x00030008;
	static final public int ImageTableMoreThanOne_Error=0x00030009;
	static final public int SpecTableMoreThanOne_Error=0x00030010;
	static final public int SelectItemOutOfDNVector_Error=0x00030011;
	static final public int ContainsTable_Error=0x00030012;
	static final public int SearchConditionOutOfDNVector_Error=0x00030013;
	static final public int Star_Error=0x00030014;
	static final public int JoinedTable_Error=0x00030015;
	static final public int JoinedTableMoreThanOne_Error=0x00030016;
	static final public int SearchCondition_Error=0x00030017;
	static final public int ImageContainsTable_Error=0x00030018;
	static final public int ImageSelectItem_Error=0x00030019;
	static final public int ADQL_Error=0x00030020;
	static final public int FromTable_Error=0x00030021;
	
	/**
	 * DAI Activity message 
	 */
	static final public int Act_Error=0x00040000;
	
	/**
	 * DAI Data Transform error message
	 */
	static final public int Tra_Error=0x00050000;
	
	/**
	 * Client error message
	 */
	static final public int Cli_Error=0x00060000;
	
	/**
	 * DAS Data node error message
	 */
	static final public int DaN_Error=0x00070000;
	/**
	 * Your can append new error message string in CommonMessage
	 */
	static public String[] CommonMessage={
			"General Error.",
			"Connect Error."
	};
	static public String[] EngineMessage={
			"DAS Engine error."
	};
	static public String[] ParserMessage={
			"ADQL Parser  error.",/*0*/
			"ADQL Syntax error.",/*1*/
			"ADQL Expression error."/*2*/
	};
	static public String[] ExPlanMessage={
			"DAS Execution Plan error.",/*0*/
			"...",/*1*/
			"DataNode Not Found Exception.",/*2*/
			"Get Table Type Exception.",/*3*/
			"CheckDNTable Exception.",/*4*/
			"CheckDNColumns Exception.",/*5*/
			"TableName Error.",/*6*/
			"Columns Name Error.",/*7*/
			"Table Type Not One Error.",/*8*/
			"Image Table More Than One Error.",/*9*/
			"Spec Table More Than One Error.",/*10*/
			"SelectItem Out Of DNVector Error.",/*11*/
			"ContainsTable Error.",/*12*/
			"SearchCondition Out Of DNVector Error.",/*13*/
			"Star Error.",/*14*/
			"JoinedTable Error.",/*15*/
			"JoinedTable More Than One Error.",/*16*/
			"SearchCondition Error.",/*17*/
			"Image ContainsTable Error.",/*18*/
			"Image SelectItem Error.",/*19*/
			"ADQL Error : no from or no select.",/*20*/
			"From Table Error."/*21*/
			
	};
	static public String[] RegProxyMessage={
			"DAS Registry Proxy error."
	};
	static public String[] ClientMessage={
			"DAS Client error."
	};
	static public String[] DataNodeMessage={
			"DAS Data Node error."
	};
	static public String getExceptionMessage(int ind){
		String ret="";
		int cate=(ind&0xffff0000)>>16;
		int msg=ind&0x0000ffff;
		switch(cate){
		case 0://general
			break;
		case 2://parse
			ret=ParserMessage[msg];
			break;
		case 3://ExecPlan			
			ret=ExPlanMessage[msg];
			break;
		}
		return ret;
	}
	static public void main(String[] args){
		System.out.println(ExceptionMessage.getExceptionMessage(ExceptionMessage.DataNodeNotFoundException));
	}
}
