package org.china.vo.das.registry;

import java.io.*;
import java.net.*;
import java.util.ArrayList;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class MDDataResource extends MetaData {

	private MDItemCollection collection;

	private MDItemCuration curation;

	private MDItemGeneralContent generalcontent;

	private MDItemIdentity identity;

	private MDItemDataQuality quality;

	private MDItemService Service;

	private String xmlString = "";

	private ArrayList tables = new ArrayList();

	private String DNType;

	public int getTableNum() {

		return tables.size();

	}

	public boolean hasTable(String tableName) {
		for (int tableNum = 0; tableNum < tables.size(); tableNum++) {
			MDTable mdTable = (MDTable) tables.get(tableNum);
			if (mdTable.getName().equals(tableName))
				return true;
		}
		return false;

	}

public boolean hasColumn(String TableName, String ColumnName){
		
		for(int tableNum=0;tableNum<tables.size();tableNum++){
			MDTable mdTable =(MDTable)tables.get(tableNum);
			if(mdTable.getName().equals(TableName))
			{	ArrayList colList = mdTable.getColumns();
				for(int j=0;j<colList.size();j++)
				{
					MDField mdfield = (MDField)colList.get(j);
					if(mdfield.getname().equals(ColumnName))
						return true;					
				}
			
			}	
		}
		 return false;
		
	}	public void setDNType(String newDNType) {
		DNType = newDNType;
	}

	public String getXmlString() {
		return xmlString;
	}

	public void setXmlString(String xmlString) {
		this.xmlString = xmlString;
	}

	public String getDNType() {
		return generalcontent.getType();
	}

	public MDItemCollection getCollection() {
		return collection;
	}

	public void setCollection(MDItemCollection collection) {
		this.collection = collection;
	}

	public MDItemCuration getCuration() {
		return curation;
	}

	public void setCuration(MDItemCuration curation) {
		this.curation = curation;
	}

	public MDItemGeneralContent getGeneralcontent() {
		return generalcontent;
	}

	public void setGeneralcontent(MDItemGeneralContent generalcontent) {
		this.generalcontent = generalcontent;
	}

	public MDItemIdentity getIdentity() {
		return identity;
	}

	public void setIdentity(MDItemIdentity identity) {
		this.identity = identity;
	}

	public MDItemDataQuality getQuality() {
		return quality;
	}

	public void setQuality(MDItemDataQuality quality) {
		this.quality = quality;
	}

	public MDItemService getService() {
		return Service;
	}

	public void setService(MDItemService service) {
		Service = service;
	}

	public ArrayList getTables() {
		return tables;
	}

	public void setTables(String tableurl) throws ParserConfigurationException, SAXException,
			IOException {
		// should get the metadata file first, now useing the local file
		// instead.
		
		
//		File configfile = new File("C:\\votable_3galx_delData_forGD.xml");
		javax.xml.parsers.DocumentBuilderFactory dbf = DocumentBuilderFactory
				.newInstance();
		// Tell the factory what kind of parser we want
		dbf.setValidating(false);
		// Use the factory to get a JAXP parser object
		javax.xml.parsers.DocumentBuilder parser = dbf.newDocumentBuilder();
		// Tell the parser how to handle errors. Note that in the JAXP API,
		// DOM parsers rely on the SAX API for error handling
		parser.setErrorHandler(new org.xml.sax.ErrorHandler() {
			public void warning(SAXParseException e) {
				System.err.println("WARNING: " + e.getMessage());
			}

			public void error(SAXParseException e) {
				System.err.println("ERROR: " + e.getMessage());
			}

			public void fatalError(SAXParseException e) throws SAXException {
				System.err.println("FATAL: " + e.getMessage());
				throw e; // re-throw the error
			}
		});
		
		
	   /*added by hjtian 2008-05-19*/
		String[] tu  = tableurl.split("/");
		tableurl = tu[0] + "/" + tu[1] + "/" + tu[2]+ "/metadata.xml";
		/*added by hjtian 2008-05-19*/
		org.w3c.dom.Document document = parser.parse(tableurl);

		NodeList tableNodes = document.getElementsByTagName("TABLE");
		int tableNum = tableNodes.getLength();
		System.out.println("The DBResource has " + tableNum + "  tables");

		for (int i = 0; i < tableNum; i++) {
			MDTable mdTable = new MDTable();

			Element tableTag = (Element) tableNodes.item(i);

			System.out.println("Begin make the NO." + (i + 1) + " table!");

			mdTable.setName(tableTag.getAttribute("name"));
			mdTable.setDescription(RegistryProxy.getNodeValue(tableTag,
					"DESCRIPTION"));
			System.out.println("Finished get the tables description!");

			NodeList fieldList = tableTag.getElementsByTagName("FIELD");
			int fieldNum = fieldList.getLength();

			System.out.println("This table has " + fieldNum + " cloumns");

			for (int j = 0; j < fieldNum; j++) {

				System.out.println("Begin making NO." + (j + 1) + " cloumns");

				MDField mdField = new MDField();
				mdField.setname(((Element) (fieldList.item(j)))
						.getAttribute("name"));
				// System.out.println("got name");

				mdField.setucd(((Element) (fieldList.item(j)))
						.getAttribute("ucd"));
				// System.out.println("got ucd"
				// + ((Element) (fieldList.item(j))).getAttribute("ucd"));

				mdField.setunit(((Element) (fieldList.item(j)))
						.getAttribute("unit"));
				// System.out.println("got unit");

				mdField.setdatatype(((Element) (fieldList.item(j)))
						.getAttribute("datatype"));
				// System.out.println("got datatype");

				mdField.setWidth(((Element) (fieldList.item(j)))
						.getAttribute("width"));
				
				mdField.setPrecision(((Element) (fieldList.item(j)))
						.getAttribute("precision"));
				
				mdField.setID(((Element) (fieldList.item(j)))
						.getAttribute("ID"));
				
				mdField.setdescription(getFieldDes(fieldList.item(j)));
				// System.out.println("got desc\t"
				// + getFieldDes(fieldList.item(j)));

				mdField.setXmlString(RegistryProxy.NodetoString(fieldList
						.item(j)));

				mdTable.setColumns(mdField);
				System.out.println("check the columns in this table now is: "
						+ mdTable.getColumnsNum());
				System.out.println("check the MDField xmlString: "
						+ mdField.getXmlString());
				System.out.println("set mdfield successfully");
			}

			String tablexml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><TABLE name=\""
					+ mdTable.getName()
					+ "\"><DESCRIPTION>"
					+ mdTable.getDescription() + "</DESCRIPTION></TABLE>";
			mdTable.setXmlString(tablexml);
			System.out.println("The XMLString of this table is :" + tablexml);

			tables.add(mdTable);
			System.out.println("Now we have add " + this.getTableNum()
					+ " tables");
		}
		System.out.println("Now we have add " + this.getTableNum() + " tables");
	}

	public String getFieldDes(Node fieldNode) {
		if (fieldNode.hasChildNodes() == true) {
			Element decTag = (Element) fieldNode;
			NodeList declist = decTag.getElementsByTagName("DESCRIPTION");
			String dec = ((Text) (declist.item(0).getFirstChild())).getData()
					.trim();
			return dec;
		}

		else {
			return "NOT PROVIDED";
		}
	}
	/*added by LC 2008-05-07*/
	public String getSpecFilePathColumn(String tablename){
		String pathname="";
		for(int tableNum=0;tableNum<tables.size();tableNum++){
			MDTable mdTable =(MDTable)tables.get(tableNum);
			if(mdTable.getName().equals(tablename))
			{	ArrayList colList = mdTable.getColumns();
				for(int j=0;j<colList.size();j++)
				{
					MDField mdfield = (MDField)colList.get(j);
					if(mdfield.getucd().equalsIgnoreCase("meta.ref.uri")){
						pathname=mdfield.getname();
						break;
						}
				}			
			}	
		}
		 
		return pathname;
	}
	/*added by LC 2008-05-07*/
}
