package org.china.vo.das.registry;

import java.io.*;
import java.net.*;
//import java.util.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.china.vo.das.datanode.DataResource;
import org.china.vo.das.datanode.DataResourceMap;
import org.china.vo.das.service.ServerConfigure;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
//import org.w3c.dom.*; // W3C DOM classes for traversing the document
//import org.xml.sax.*; // SAX classes used for error handling by JAXP
//import javax.xml.parsers.*; // JAXP classes for parsing
import javax.xml.transform.*; // For transforming a DOM tree to an XML file.

public class RegistryProxy {
	// private static String theurl =
	// "http://voservices.net/Registry/registry.asmx/QueryResource?predicate=ResourceType%20like%20'CONE'";

	// private static String thefile = "C:\\registry2_forGD.xml";
	private String thefile = null;// =
									// "http://159.226.169.50:8080/registry.xml";
	// private static String thefile = "http://192.168.3.114:8080/registry.xml";

	/*
	 * Modified by Haijun Tian 2008-04-14 Get the Registry URL through the
	 * ServerConfigure File, server.xml
	 */

	public RegistryProxy() {
		ServerConfigure sc;
		sc = new ServerConfigure();
		String filepath = sc.getFilePath();
		try {
			sc.parseConfigureFile(filepath);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.thefile = sc.getRegistryurl();
	}

	public void discover(DataResourceMap dataResourceMap) throws Exception {

		dealXML(dataResourceMap);

	}

	public void dealXML(DataResourceMap dataResourceMap) throws IOException,
			SAXException, ParserConfigurationException {

		//
		org.w3c.dom.Document document;

		// File configfile = new File(thefile); //read local xml

		javax.xml.parsers.DocumentBuilderFactory dbf = DocumentBuilderFactory
				.newInstance();
		// Tell the factory what kind of parser we want
		dbf.setValidating(false);
		// Use the factory to get a JAXP parser object
		javax.xml.parsers.DocumentBuilder parser = dbf.newDocumentBuilder();

		// Tell the parser how to handle errors. Note that in the JAXP API,
		// DOM parsers rely on the SAX API for error handling
		parser.setErrorHandler(new org.xml.sax.ErrorHandler() {
			public void warning(SAXParseException e) {
				System.err.println("WARNING: " + e.getMessage());
			}

			public void error(SAXParseException e) {
				System.err.println("ERROR: " + e.getMessage());
			}

			public void fatalError(SAXParseException e) throws SAXException {
				System.err.println("FATAL: " + e.getMessage());
				throw e; // re-throw the error
			}
		});

		// Finally, use the JAXP parser to parse the file. This call returns
		// A Document object. Now that we have this object, the rest of this
		// class uses the DOM API to work with it; JAXP is no longer required.
		// document = parser.parse(configfile);
		document = parser.parse(thefile);

		NodeList servletnodes = document.getElementsByTagName("DBResource");
		int numservlets = servletnodes.getLength();
		// System.out.println(numservlets);
		System.out.println("Now make the DataResources and put them to Map");
		for (int i = 0; i < numservlets; i++) {
			System.out.println("Begin make\t NO." + (i + 1) + "   DBResource");

			Element dbrTag = (Element) servletnodes.item(i);

			MDDataResource mdDR = new MDDataResource();
			MDItemDataQuality itemdataQ = new MDItemDataQuality();
			MDItemIdentity itemItemI = new MDItemIdentity();
			MDItemCuration itemCuration = new MDItemCuration();
			MDItemGeneralContent itemG = new MDItemGeneralContent();
			MDItemService itemS = new MDItemService();
			MDItemCollection itemCollection = new MDItemCollection();
			MDItemServiceInterface itemSI = new MDItemServiceInterface();
			MDItemServiceCapibility itemSC = new MDItemServiceCapibility();
			MDItemResolution itemR = new MDItemResolution();
			MDItemCoverage itemCoverage = new MDItemCoverage();

			System.out.println("finished init");

			mdDR.setQuality(itemdataQ);

			itemItemI.setTitle(getNodeValue(dbrTag, "Title"));
			// System.out.println(getNodeValue(dbrTag, "Title"));
			itemItemI.setShortname(getNodeValue(dbrTag, "ShortName"));
			// System.out.println(getNodeValue(dbrTag, "ShortName"));
			itemItemI.setIdentifier(getNodeValue(dbrTag, "Identifier"));
			// System.out.println(getNodeValue(dbrTag, "Identifier"));

			System.out.println("get indentity succesfully");
			mdDR.setIdentity(itemItemI);

			itemCuration.setPublisher(getNodeValue(dbrTag,
					"CurationPublisherName"));
			itemCuration.setPublisherID(getNodeValue(dbrTag,
					"CurationPublisherIdentifier"));
			// //Modified by tian at 2008-04-10
			itemCuration.setPublisherdescription(getNodeValue(dbrTag,
					"CurationPublisherDescription"));

			itemCuration.setPublisherreferenceurl(getNodeValue(dbrTag,
					"CurationPublisherReferenceUrl"));
			// /////
			itemCuration
					.setCreator(getNodeValue(dbrTag, "CurationCreatorName"));
			itemCuration.setContributor(getNodeValue(dbrTag,
					"CurationContributor"));
			itemCuration.setDate(getNodeValue(dbrTag, "CurationDate"));
			itemCuration.setVersion(getNodeValue(dbrTag, "CurationVersion"));
			itemCuration.setContactname(getNodeValue(dbrTag,
					"CurationContactName"));
			// System.out.println(getNodeValue(dbrTag,"CurationContactName"));
			itemCuration.setContactemail(getNodeValue(dbrTag,
					"CurationContactEmail"));

			mdDR.setCuration(itemCuration);

			itemG.setSubject(getNodeValue(dbrTag, "Subject"));
			itemG.setDescription(getNodeValue(dbrTag, "Description"));
			// System.out.println(getNodeValue(dbrTag,"Description"));
			

			itemG.setReferenceURL(getNodeValue(dbrTag, "ReferenceURL"));
			
			itemG.setType(getNodeValue(dbrTag, "Type"));
			itemG.setContentlevel(getNodeValue(dbrTag, "ContentLevel"));

			mdDR.setGeneralcontent(itemG);

			itemSI.setInterfaceURL(getNodeValue(dbrTag, "ServiceURL"));

			itemS.setInterfaces(itemSI);

			itemSC.setMaxRecords(getNodeValue(dbrTag, "MaxRecords"));
			itemS.setCapibility(itemSC);

			mdDR.setService(itemS);
			
			/*added by LC 2008-05-07*/
			mdDR.setDNType(getNodeValue(dbrTag,"Type"));
			/*added by LC 2008-05-07*/
			
			itemCollection.setFacility(getNodeValue(dbrTag, "Facility"));
			itemCollection.setInstrument(getNodeValue(dbrTag, "Instrument"));
			// System.out.println(getNodeValue(dbrTag,"Instrument"));
			itemCoverage.setSpatial(getNodeValue(dbrTag, "CoverageSpatial"));
			// System.out.println(getNodeValue(dbrTag,"CoverageSpatial"));
			itemCoverage.setSpcectral(getNodeValue(dbrTag, "CoverageSpectral"));
			itemCoverage.setRegionofregards(getNodeValue(dbrTag,
					"CoverageRegionOfRegard"));

			// attention
			itemR.setTemporal(getNodeValue(dbrTag, "CoverageTemporal"));

			itemCollection.setResolution(itemR);
			itemCollection.setCoverage(itemCoverage);

			mdDR.setCollection(itemCollection);

			mdDR.setXmlString(NodetoString(servletnodes.item(i)));
			// System.out.println(NodetoString(servletnodes.item(i)));

			try {
				/*
				 * Modified by tian
				mdDR.setTables(itemG.getReferenceURL());
				*/
				
				//Add by tian
				mdDR.setTables(itemSI.getInterfaceURL());
				//
				
			} catch (Exception e) {
				System.out.println("Can't make\t NO." + (i + 1)
						+ "  DBResource");
				System.err.println(e);
				continue;
			}

			DataResource dr = new DataResource();
			dr.setDrMDDataResource(mdDR);

			dataResourceMap.dataResourceMap.put(dr.getDrMDDataResource()
					.getIdentity().getTitle(), dr);
			System.out.println("finish make\t NO." + (i + 1) + "  DBResource");

		} // end of for

	}

	public static String getNodeValue(Element bigTag, String nodeName)
			throws NullPointerException {

		System.out.println("Inside getNodeValue\t" + nodeName + "\t");

		// if (bigTag.getElementsByTagName(nodeName) == null) {
		// System.out.println("nodename error!");
		// return "NOT PROVIDED";
		// }

		try {
			Node aTag2 = bigTag.getElementsByTagName(nodeName).item(0);
			if (aTag2.getFirstChild() == null) {
				System.out.println("Found node like <**></**>");
				return "NOT PROVIDED";
			}
			String tagName = ((Element) aTag2).getTagName();
			if (tagName.equals("Subject") || tagName.equals("Instrument")
					|| tagName.equals("ContentLevel")
					|| tagName.equals("CoverageSpectral")) {
				NodeList stringList = ((Element) aTag2)
						.getElementsByTagName("string");
				int stringNum = stringList.getLength();
				String strings = "";
				// if (stringNum == 0) {
				//
				// return "NOT PROVIDED";
				// }
				for (int i = 0; i < stringNum; i++) {
					if (stringList.item(i).getFirstChild() == null) {
						System.out
								.println("Found node like <ContentLevel>\n<string/>\n</ContentLevel>");
						strings += "NOT PROVIDED" + "\n";
					} else {
						strings += ((Text) (stringList.item(i).getFirstChild()))
								.getData().trim()
								+ "\n";
					}
				}
				return stringNum + "\t" + strings;
			} else {

				String tagvalue2 = ((Text) aTag2.getFirstChild()).getData()
						.trim();
				return tagvalue2;
			}
		} catch (NullPointerException e) {
			System.out.println("The nodename is not supported!");
			return "NOT PROVIDED";
		}

	}

	public static String NodetoString(Node node) {
		Transformer transformer = null;
		String result = null;
		if (node == null) {
			throw new IllegalArgumentException();
		}
		try {
			transformer = TransformerFactory.newInstance().newTransformer();
		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
		if (transformer != null) {
			try {
				StringWriter sw = new StringWriter();
				transformer.transform(new javax.xml.transform.dom.DOMSource(
						node), new javax.xml.transform.stream.StreamResult(sw));
				return sw.toString();
			} catch (TransformerException te) {
				throw new RuntimeException(te.getMessage());
			}
		}
		return result;
	}

	public String getname(MetaData theMetaData) {
		return theMetaData.getIdentity().getTitle();
	}

	public String getInterfaceURL(MetaData theMetaData) {
		return theMetaData.getService().getInterfaces().getInterfaceURL();
	}
	
	
	
	public static void main(String[] args) {

		try {
			DataResourceMap drM = DataResourceMap.getInstance();
			RegistryProxy rp = new RegistryProxy();
			rp.discover(drM);
		} catch (Exception e) {
			System.err.println(e);
		}
	}

}
