package org.china.vo.das.service;

import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

import net.ivoa.adql.ADQLToken;
import net.ivoa.adql.And;
import net.ivoa.adql.ArchiveTableItem;
import net.ivoa.adql.Column;
import net.ivoa.adql.CompareOp;
import net.ivoa.adql.DBObject;
import net.ivoa.adql.From;
import net.ivoa.adql.Not;
import net.ivoa.adql.Or;
import net.ivoa.adql.Region;
import net.ivoa.adql.SearchCondition;
import net.ivoa.adql.SelectClause;
import net.ivoa.adql.SelectItem;
import net.ivoa.adql.SelectStatement;
import net.ivoa.adql.SubTableSource;
import net.ivoa.adql.TableSources;
import net.ivoa.adql.TrueCond;
import net.ivoa.adql.Where;
import net.ivoa.adql.XMatch;
import net.ivoa.adql.ArchiveTable;
import net.ivoa.adql.exceptions.DBObjectNotFoundException;
import net.ivoa.adql.exceptions.TableItemNotFoundException;

import org.china.vo.das.activity.client.SQLResult2VOTableClient;
import org.china.vo.das.datanode.DataResource;
import org.china.vo.das.datanode.DataResourceMap;
import org.china.vo.das.exceptions.ADQLErrorException;
import org.china.vo.das.exceptions.CheckDNColumnsException;
import org.china.vo.das.exceptions.CheckDNTableException;
import org.china.vo.das.exceptions.ContainsTableErrorException;
import org.china.vo.das.exceptions.DataNodeNotFoundException;
import org.china.vo.das.exceptions.DataNodePerformException;
import org.china.vo.das.exceptions.ExceptionMessage;
import org.china.vo.das.exceptions.FromTableErrorException;
import org.china.vo.das.exceptions.GetTableTypeException;
import org.china.vo.das.exceptions.ImageContainsTableErrorException;
import org.china.vo.das.exceptions.ImageSelectItemErrorException;
import org.china.vo.das.exceptions.ImageTableMoreThanOneErrorException;
import org.china.vo.das.exceptions.JoinedTableErrorException;
import org.china.vo.das.exceptions.JoinedTableMoreThanOneErrorException;
import org.china.vo.das.exceptions.SearchConditionErrorException;
import org.china.vo.das.exceptions.SearchConditionOutOfDNVectorErrorException;
import org.china.vo.das.exceptions.SelectItemOutOfDNVectorErrorException;
import org.china.vo.das.exceptions.SpecTableMoreThanOneErrorException;
import org.china.vo.das.exceptions.StarErrorException;
import org.china.vo.das.exceptions.TableNotFoundErrorException;
import org.china.vo.das.exceptions.TableTypeNotOneErrorException;
import org.china.vo.das.log.DASLog;

import org.china.vo.das.registry.*;
import org.china.vo.das.parser.*;

import uk.org.ogsadai.client.toolkit.GenericServiceFetcher;
import uk.org.ogsadai.client.toolkit.Response;
import uk.org.ogsadai.client.toolkit.activity.ActivityRequest;
import uk.org.ogsadai.client.toolkit.activity.delivery.DTOutputStream;
import uk.org.ogsadai.client.toolkit.activity.delivery.DataTransportMode;
import uk.org.ogsadai.client.toolkit.activity.delivery.DeliverFromDT;
import uk.org.ogsadai.client.toolkit.activity.delivery.DeliverToURL;
import uk.org.ogsadai.client.toolkit.activity.sql.CSV;
import uk.org.ogsadai.client.toolkit.activity.sql.SQLBulkLoad;
import uk.org.ogsadai.client.toolkit.activity.sql.SQLQuery;
import uk.org.ogsadai.client.toolkit.activity.sql.SQLUpdate;
import uk.org.ogsadai.client.toolkit.activity.sql.WebRowSet;
import uk.org.ogsadai.client.toolkit.exception.AuthorisationException;
import uk.org.ogsadai.client.toolkit.exception.DataFormatException;
import uk.org.ogsadai.client.toolkit.exception.RequestException;
import uk.org.ogsadai.client.toolkit.exception.ResourceBusyException;
import uk.org.ogsadai.client.toolkit.exception.ResourceUnknownException;
import uk.org.ogsadai.client.toolkit.exception.ServerException;
import uk.org.ogsadai.client.toolkit.exception.ServiceCommsException;
import uk.org.ogsadai.client.toolkit.properties.RequestStatus;
import uk.org.ogsadai.client.toolkit.service.DataService;
import uk.org.ogsadai.client.toolkit.sessions.JoinNewSession;
import uk.org.ogsadai.client.toolkit.sessions.Session;
import uk.org.ogsadai.converters.csv.CSVConfigurationException;
import uk.org.ogsadai.converters.csv.CSVConfigurator;

public class ExecPlan {

	/** Activity input name * */
	DASLog daslog = new DASLog();

	private Session session = null;

	private String targetURL = "ftp://naoc:astronomy@info.bao.ac.cn/pub/incoming/tian/result2.dat";

	private Vector arDN = new Vector();

	SelectStatement ss = new SelectStatement();

	Vector vAlias = new Vector();

	Vector vArchiveTable = new Vector();

	Vector vDBObject = new Vector();

	Vector vDN = new Vector();

	// getColumns()
	Vector vvAlias = new Vector();

	Vector vvColumns = new Vector();

	boolean hasJoinedTable = false;// *

	Vector joinedTableAlias = new Vector();// *

	int jointype = 0;
	/*removed by LC 2008-05-07*/
/*
	boolean hasCatalogue = false;

	boolean hasImage = false;

	boolean hasSpec = false;
*/
	/*removed by LC 2008-05-07*/
	Map DNVectorMap = new HashMap();

	Vector DNSequence = new Vector();

	Vector DNVector = new Vector();

	Map ImageDNVectorMap = new HashMap();

	Map SpecDNVectorMap = new HashMap();

	Vector ImageDNVector = new Vector();

	Vector SpecDNVector = new Vector();

	Vector ImageDNSequence = new Vector();

	Vector SpecDNSequence = new Vector();

	Vector DNCol = new Vector();

	Vector DNCondi = new Vector();

	Vector DNGroup = new Vector();

	Vector DNHaving = new Vector();

	Vector DNOrder = new Vector();

	Vector ImageDNCol = new Vector();

	Vector SpecDNCol = new Vector();

	String sql = new String();

	Vector vsql = new Vector();

	String tree = new String();

	String rade_xmatch = new String();// radeg_rade_xmatch,dedeg_rade_xmatch

	int treecount = -1;

	int r1 = 5;

	int r2 = 5;

	String dnAlias1 = "";// Region
	Vector radeccolnames;//for Region & XMatch

	// create upload table
	Vector tablenames = new Vector();

	Vector columnnames = new Vector();

	String queryresult = null;

	int format = 0;

	public ExecPlan(SelectStatement ss) throws ADQLErrorException,
			DataNodeNotFoundException, CheckDNTableException,
			TableNotFoundErrorException, GetTableTypeException,
			TableTypeNotOneErrorException, ImageTableMoreThanOneErrorException,
			SpecTableMoreThanOneErrorException,
			JoinedTableMoreThanOneErrorException, FromTableErrorException,
			TableItemNotFoundException, ImageSelectItemErrorException,
			ImageContainsTableErrorException, DBObjectNotFoundException,
			StarErrorException, ContainsTableErrorException,
			CheckDNColumnsException, SelectItemOutOfDNVectorErrorException,
			SearchConditionOutOfDNVectorErrorException,
			ResourceUnknownException, RequestException, DataFormatException,
			InterruptedException, ServiceCommsException, ResourceBusyException,
			AuthorisationException, SearchConditionErrorException,
			DataNodePerformException, MalformedURLException, ServerException,
			JoinedTableErrorException {

		// try{

		this.ss = ss;

		System.out.println("ExecPlan is started, and ss is:" + ss.toString());

		if (ss.getFrom().getTableSources().size() != 0
				&& ss.getSelectClause().getSelectItems().length != 0) {

			execFrom();
			System.out.println("execFrom finished");
			execSelect();
			execWhere();
			buildActivityRequest();
		} else {
			daslog.error(0x00030020);
			daslog.debug(ExceptionMessage
					.getExceptionMessage(ExceptionMessage.ADQL_Error));
			throw new ADQLErrorException();
		}
		// }catch(Exception e){
		// e.getStackTrace();
		// }
	}

	public ExecPlan() {

	}

	void execFrom() throws DataNodeNotFoundException, CheckDNTableException,
			TableNotFoundErrorException, GetTableTypeException,
			TableTypeNotOneErrorException, ImageTableMoreThanOneErrorException,
			SpecTableMoreThanOneErrorException,
			JoinedTableMoreThanOneErrorException, FromTableErrorException {

		From from = ss.getFrom();

		Vector vts = from.getTableSources();

		System.out.println("execFrom is started:");
		TableSources[] ts = new TableSources[vts.size()];
		for (int i = 0; i < vts.size(); i++) {
			System.out.println("execFrom is started, and enter for");
			ts[i] = (TableSources) vts.get(i);
		}
		//
		// SubTableSource sts1 = new SubTableSource();
		// SubTableSource sts2 = new SubTableSource();
		// SubTableSource sts3 = new SubTableSource();
		// SubTableSource sts4 = new SubTableSource();
		// JoinedTable jt = new JoinedTable();
		// TableSources[] ts = new TableSources[5];
		// ts[0]=sts1;
		// ts[1]=sts2;
		// ts[2]=sts3;
		// ts[3]=sts4;
		// ts[4]=jt;
		//

		// for each TableSource checkTable
		for (int i = 0; i < ts.length; i++) {

			if (ts[i].getClass().getName().equals(
					"net.ivoa.adql.SubTableSource")) {

				// DataResource dn = new DataResource();
				ArchiveTableItem ati = ts[i].getArchiveTableItem();
				if (((SubTableSource) ts[i]).getAlias() == null
						|| ati.getArchiveTable() == null
						|| ati.getTableName() == null) {
					daslog.error(0x00030021);
					daslog
							.debug(ExceptionMessage
									.getExceptionMessage(ExceptionMessage.FromTable_Error));
					throw new FromTableErrorException();
				}
				vAlias.add(((SubTableSource) ts[i]).getAlias());
				vArchiveTable.add(ati.getArchiveTable());
				vDBObject.add(ati.getTableName());
				DataResourceMap dnm = DataResourceMap.getInstance();
				// System.out.println(dnm.size());
				// System.out.println(ati.getArchiveTable().getADQLString());
				// RegistryProxy rp = new RegistryProxy();
				// rp.discover(dnm);
				// System.out.println(dnm.size());
				// dnm.addDataResource(ati.getArchiveTable().getADQLString(),dn);
				// DataResource dn =
				// dnm.lookupByDRName(ati.getArchiveTable().getADQLString());//DASImpl.dnm

				DataResource dn = (DataResource) dnm.dataResourceMap.get(ati
						.getArchiveTable().getADQLString());

				// System.out.println("hello");
				vDN.add(dn); 
				// System.out.println(ati.getTableName().getADQLString());
				// if(!dn.checkDNTable(ati.getTableName().getADQLString()))
				// {
				// daslog.error(0x00030006);
				// daslog.debug(ExceptionMessage.getExceptionMessage(ExceptionMessage.TableNotFound_Error));
				// throw new TableNotFoundErrorException() ;
				// }

			} else if ((!hasJoinedTable)
					&& ts[i].getClass().getName().equals(
							"net.ivoa.adql.JoinedTable")) {
				// hasJoinedTable=true;
				// jointype = ((JoinedTable)ts[i]).getJoinType();
				// Vector tables = ((JoinedTable)ts[i]).getTableSources();
				// for(int j=0;j<2;j++)
				// {
				// ArchiveTableItem ati =
				// ((JoinedTable)tables.get(i)).getArchiveTableItem();
				//
				// vAlias.add(ati.getAlias());
				// vArchiveTable.add(ati.getArchiveTable());
				// vDBObject.add(ati.getTableName());
				// joinedTableAlias.add(ati.getAlias());
				// DataResourceMap dnm = new DataResourceMap();
				// dn =
				// dnm.lookupByDRName(ati.getArchiveTable().getADQLString());
				// vDN.add(dn);
				// if(!dn.checkDNTable(ati.getTableName().toString()))
				// {
				// daslog.error(0x00030006);
				// daslog.debug(ExceptionMessage.getExceptionMessage(ExceptionMessage.TableNotFound_Error));
				// throw new TableNotFoundErrorException() ;
				// }
				// }
				//				
			} else if ((hasJoinedTable)
					&& ts[i].getClass().getName().equals(
							"net.ivoa.adql.JoinedTable")) {
				daslog.error(0x00030016);
				daslog
						.debug(ExceptionMessage
								.getExceptionMessage(ExceptionMessage.JoinedTableMoreThanOne_Error));
				throw new JoinedTableMoreThanOneErrorException();
			}

		}

		// for each Alias, get tableType Map
		for (int i = 0; i < vAlias.size(); i++) {
			DataResource datanode = (DataResource) vDN.get(i);
			//int type = datanode.getTableType();
			/*added by LC 2008-05-07*/
			if (DNVectorMap.containsKey(datanode)) {//have already contains the table
				Vector vt = (Vector) DNVectorMap.get(datanode);
				vt.add(vAlias.get(i));
				DNVectorMap.remove(datanode);
				DNVectorMap.put(datanode, vt);
			} else {//new comer
				Vector vt = new Vector();
				vt.add(vAlias.get(i));
				DNVectorMap.put(datanode, vt);
				DNVector.add(datanode);
			}
			/*added by LC 2008-05-07*/
			/*removed by LC 2008-05-06*/
			/*
			if (type == 1)// Catalogue
			{
				hasCatalogue = true;
				if (DNVectorMap.containsKey(datanode)) {
					Vector vt = (Vector) DNVectorMap.get(datanode);
					vt.add(vAlias.get(i));
					DNVectorMap.remove(datanode);
					DNVectorMap.put(datanode, vt);
				} else {
					Vector vt = new Vector();
					vt.add(vAlias.get(i));
					DNVectorMap.put(datanode, vt);
					DNVector.add(datanode);
				}
			} else if (type == 2)// Image
			{
				hasImage = true;
				if (ImageDNVectorMap.containsKey(datanode)) {
					Vector vt = (Vector) ImageDNVectorMap.get(datanode);
					vt.add(vAlias.get(i));
					ImageDNVectorMap.remove(datanode);
					ImageDNVectorMap.put(datanode, vt);
				} else {
					Vector vt = new Vector();
					vt.add(vAlias.get(i));
					ImageDNVectorMap.put(datanode, vt);
					ImageDNVector.add(datanode);
				}
			} else if (type == 3)// Spec
			{
				hasSpec = true;
				if (SpecDNVectorMap.containsKey(datanode)) {
					Vector vt = (Vector) SpecDNVectorMap.get(datanode);
					vt.add(vAlias.get(i));
					SpecDNVectorMap.remove(datanode);
					SpecDNVectorMap.put(datanode, vt);
				} else {
					Vector vt = new Vector();
					vt.add(vAlias.get(i));
					SpecDNVectorMap.put(datanode, vt);
					SpecDNVector.add(datanode);
				}
			}*/
			/*removed by LC 2008-05-06*/
		}
		/*added by LC 2008-05-08*/
		
		for (int i = 0; i < DNVector.size(); i++)
			DNSequence.add(DNVector.get(i));
		
		/*added by LC 2008-05-07*/
		/*removed by LC 2008-05-06*/
		/*
		// DNSequence ImageDNSequence SpecDNSequence
		if ((!(hasCatalogue || hasImage || hasSpec))
				|| (hasCatalogue && hasImage) || (hasCatalogue && hasSpec)
				|| (hasImage && hasSpec)) {
			daslog.error(0x00030008);
			daslog
					.debug(ExceptionMessage
							.getExceptionMessage(ExceptionMessage.TableTypeNotOne_Error));
			throw new TableTypeNotOneErrorException();
		}
		
		if (hasCatalogue) {

			for (int i = 0; i < DNVector.size(); i++)
				DNSequence.add(DNVector.get(i));
		} else if (hasImage) {
			if (ImageDNVector.size() != 1) {
				daslog.error(0x00030009);
				daslog
						.debug(ExceptionMessage
								.getExceptionMessage(ExceptionMessage.ImageTableMoreThanOne_Error));
				throw new ImageTableMoreThanOneErrorException();
			}
			for (int i = 0; i < ImageDNVector.size(); i++)
				ImageDNSequence.add(ImageDNVector.get(i));
		} else if (hasSpec) {
			if (SpecDNVector.size() != 1) {
				daslog.error(0x00030010);
				daslog
						.debug(ExceptionMessage
								.getExceptionMessage(ExceptionMessage.SpecTableMoreThanOne_Error));
				throw new SpecTableMoreThanOneErrorException();
			}
			for (int i = 0; i < SpecDNVector.size(); i++)
				//SpecDNSequence.add(SpecDNVector.get(i));//modified by LC 2008-05-07
				DNSequence.add(SpecDNVector.get(i));
			
		}*/
		/*removed by LC 2008-05-06*/
	}

	void execSelect() throws TableItemNotFoundException,
			DBObjectNotFoundException, CheckDNTableException,
			CheckDNColumnsException, SelectItemOutOfDNVectorErrorException,
			ContainsTableErrorException, StarErrorException,
			ImageContainsTableErrorException, ImageSelectItemErrorException ,
			SpecTableMoreThanOneErrorException{
		/*added by LC 2008-05-07*/
		catalogSelect();
		/*added by LC 2008-05-07*/
/*removed by LC 2008-05-07*/
		/*
		if (hasCatalogue) {
			catalogSelect();
		} 
		if(hasImage) {

		} 
		if (hasSpec) {
			
		}
		*/
		/*removed by LC 2008-05-07*/

	}

	void catalogSelect() throws TableItemNotFoundException,
			DBObjectNotFoundException, CheckDNTableException,
			CheckDNColumnsException, SelectItemOutOfDNVectorErrorException,
			ContainsTableErrorException, StarErrorException {

		SelectClause sc = ss.getSelectClause();
		SelectItem[] si = sc.getSelectItems();
		Column[] sic = new Column[si.length];
		for (int i = 0; i < si.length; i++) {
			sic[i] = (Column) si[i];
		}
		sc.getTop();
		sc.getDinstinct();

		// Catalogue
		Vector vector1 = new Vector();

		// for each DN
		for (int i = 0; i < DNSequence.size(); i++) {

			Vector vDNCol = new Vector();
			Vector v = new Vector();
			v = (Vector) DNVectorMap.get(DNSequence.get(i));

			for (int j = 0; j < v.size(); j++) {
				vector1.add(v.get(j));
			}

			// for each SelectItem
			for (int j = 0; j < si.length; j++) {

				int ct = sic[j].containsTables(vector1);

				if ((i == DNSequence.size() - 1) && (ct != 1)) {
					daslog.error(0x00030011);
					daslog
							.debug(ExceptionMessage
									.getExceptionMessage(ExceptionMessage.SelectItemOutOfDNVector_Error));
					throw new SelectItemOutOfDNVectorErrorException();
				}
				// System.out.println(ct);
				if (ct == 1) {

					vDNCol.add(sic[j]);
				} else if (ct == 2) {
					DBObject[] dbo = sic[j].getAllDBObjects();

					for (int k = 0; k < dbo.length; k++) {
						for (int m = 0; m < vector1.size(); m++) {
							// System.out.println(((DBObject)vector1.get(m)).getADQLString());

							if (((DBObject) vector1.get(m))
									.getADQLString()
									.equals((dbo[k].getFirst()).getADQLString())) {
								vDNCol.add(new Column(dbo[k]));
							}

						}
					}
				} else if (ct == 0) {

				} else // ct==3
				{
					daslog.error(0x00030012);
					daslog
							.debug(ExceptionMessage
									.getExceptionMessage(ExceptionMessage.ContainsTable_Error));
					throw new ContainsTableErrorException();
				}

			}
			DNCol.add(vDNCol);
			// for(int j=0;j<vDNCol.size();j++)
			// {
			// System.out.println(((Column)vDNCol.get(j)).getADQLString());
			// }

		}

		// for each SelectItem in last DNCol
		Vector v = (Vector) DNCol.get(DNCol.size() - 1);
		for (int i = 0; i < v.size(); i++) {
			SelectItem sitem = (SelectItem) v.get(i);
			Column sitemc = (Column) sitem;
			if (sitem.getClass().getName().equals("net.ivoa.adql.Star")) {
				if (DNCol.size() != 1) {
					daslog.error(0x00030014);
					daslog.debug(ExceptionMessage
							.getExceptionMessage(ExceptionMessage.Star_Error));
					throw new StarErrorException();
				}
			} else if (!sitem.getClass().getName().equals(
					"net.ivoa.adql.TableColumn")) {
				DBObject[] dbo = sitemc.getAllDBObjects();
				for (int k = 0; k < dbo.length; k++) {
					String alias = dbo[k].getFirst().getADQLString();
					if (!vvAlias.contains(alias)) {
						vvAlias.add(alias);
						Vector ve = new Vector();
						ve.add(dbo[k].getSecond(0));
						vvColumns.add(ve);
					} else {
						int ialias = vvAlias.indexOf(alias);
						Vector ve = new Vector();
						ve = (Vector) vvColumns.get(ialias);
						ve.add(dbo[k].getSecond(0));
						vvColumns.remove(ialias);
						vvColumns.add(ialias, ve);
					}
				}

			}

		}

		// System.out.println(vvAlias.size());
		// System.out.println(vvColumns.size());
		//		
		// for(int i=0;i<vvAlias.size();i++)
		// {
		// System.out.println((String)(vvAlias.get(i)));
		// }
		//		
		// for(int i=0;i<vvColumns.size();i++)
		// {
		// Vector vec = (Vector)vvColumns.get(i);
		// System.out.println(((Vector)vvColumns.get(i)).size());
		// for(int j=0;j<vec.size();j++)
		// {
		// System.out.println(((ADQLToken)(vec.get(j))).getADQLString());
		// }
		//				
		// }

		// for each DN
		for (int i = 0; i < DNSequence.size(); i++) {
			Vector ve = new Vector();
			ve = (Vector) DNVectorMap.get(DNSequence.get(i));
			// System.out.println(ve.size());
			// System.out.println(((DBObject)(ve.get(0))).getADQLString());
			// for each Alias
			for (int j = 0; j < ve.size(); j++) {
				// getTableName vAlias add(DBObject)
				// getColumns vvAlias add(String)
				String tablename = this.getTableName(((DBObject) (ve.get(j))));

				// System.out.println(tablename);
				Vector column = this.getColumns(((DBObject) (ve.get(j)))
						.getADQLString());
				Vector columns = new Vector();
				for (int m = 0; m < column.size(); m++) {
					columns.add(((ADQLToken) (column.get(m))).getADQLString());
				}
				// if(!((DataResource)DNSequence.get(i)).checkDNColumns(tablename,columns))
				// {
				// daslog.error(0x00030005);
				// daslog.debug(ExceptionMessage.getExceptionMessage(ExceptionMessage.CheckDNColumnsException));
				// throw new CheckDNColumnsException();
				// }

			}
		}
		vvAlias.clear();
		vvColumns.clear();
	}

	void imageSelect() throws ImageContainsTableErrorException,
			ImageSelectItemErrorException, TableItemNotFoundException,
			DBObjectNotFoundException, CheckDNTableException,
			CheckDNColumnsException {
		SelectClause sc = ss.getSelectClause();
		SelectItem[] si = sc.getSelectItems();

		sc.getTop();

		Vector vector1 = new Vector();

		// for each DN

		Vector vImageDNCol = new Vector();
		Vector v = new Vector();
		v = (Vector) ImageDNVectorMap.get(ImageDNSequence.get(0));
		for (int i = 0; i < v.size(); i++) {
			vector1.add(v.get(i));
		}

		// for each SelectItem
		for (int i = 0; i < si.length; i++) {
			int ct = si[i].containsTables(vector1);

			if (ct == 1) {
				vImageDNCol.add(si[i]);
			} else {
				daslog.error(0x00030018);
				daslog
						.debug(ExceptionMessage
								.getExceptionMessage(ExceptionMessage.ImageContainsTable_Error));
				throw new ImageContainsTableErrorException();
			}
		}
		ImageDNCol.add(vImageDNCol);

		// for each SelectItem
		Vector vec = (Vector) ImageDNCol.get(0);
		for (int i = 0; i < vec.size(); i++) {
			SelectItem sitem = (SelectItem) vec.get(i);
			if (sitem.getClass().getName().equals("net.ivoa.adql.Star")) {

			} else if (sitem.getClass().getName().equals(
					"net.ivoa.adql.TableColumn")) {

			} else if (sitem.getClass().getName()
					.equals("net.ivoa.adql.Column")) {
				DBObject[] dbo = sitem.getAllDBObjects();
				for (int k = 0; k < dbo.length; k++) {
					String alias = dbo[k].getFirst().getADQLString();
					if (!vvAlias.contains(alias)) {
						vvAlias.add(alias);
						Vector ve = new Vector();
						ve.add(dbo[k].getSecond(0));
						vvColumns.add(ve);
					} else {
						int ialias = vvAlias.indexOf(alias);
						Vector ve = new Vector();
						ve = (Vector) vvColumns.get(ialias);
						ve.add(dbo[k].getSecond(0));
						vvColumns.remove(ialias);
						vvColumns.add(ialias, ve);
					}
				}
			} else {
				daslog.error(0x00030019);
				daslog
						.debug(ExceptionMessage
								.getExceptionMessage(ExceptionMessage.ImageSelectItem_Error));
				throw new ImageSelectItemErrorException();
			}
		}

		Vector ve = new Vector();
		ve = (Vector) ImageDNVectorMap.get(ImageDNSequence.get(0));

		// for each Alias
		for (int j = 0; j < ve.size(); j++) {
			String tablename = this.getTableName(((DBObject) (ve.get(j))));
			Vector column = this.getColumns(((DBObject) (ve.get(j)))
					.getADQLString());
			Vector columns = new Vector();
			for (int m = 0; m < column.size(); m++) {
				columns.add(((ADQLToken) (column.get(m))).getADQLString());
			}
			if (!((DataResource) ImageDNSequence.get(0)).checkDNColumns(
					tablename, columns)) {
				daslog.error(0x00030005);
				daslog
						.debug(ExceptionMessage
								.getExceptionMessage(ExceptionMessage.CheckDNColumnsException));
				throw new CheckDNColumnsException();
			}
		}

		vvAlias.clear();
		vvColumns.clear();

	}

	void execWhere() throws TableItemNotFoundException,
			ContainsTableErrorException,
			SearchConditionOutOfDNVectorErrorException,
			DBObjectNotFoundException, CheckDNTableException,
			CheckDNColumnsException {
		if (ss.getWhere() != null) {

			/*if (hasCatalogue) */{//removed by LC 2008-05-07

				Where w = ss.getWhere();
				SearchCondition sc = w.getSearchCondition();

				// Catalogue
				Vector vector1 = new Vector();

				//added by LC 2008-05-22
				//radeccolnames=new Vector();
				//added by LC 2008-05-22
				// for each DN
				for (int i = 0; i < DNSequence.size(); i++) {
					
					Vector vDNCondi = new Vector();
					Vector v = new Vector();
					v = (Vector) DNVectorMap.get(DNSequence.get(i));
					for (int j = 0; j < v.size(); j++) {
						vector1.add(v.get(j));
					}
					//modified by LC for adding automatic find coordinates field 2008-05-16
					
					//v0 = (Vector) DNVectorMap.get(curDN);
					DBObject dbtable;
					String[] tablename=new String[v.size()];
					for(int k=0;k<v.size();k++){
						dbtable=(DBObject)v.get(k);						
						tablename[k]=getTableName(dbtable);
					}
//					added by LC 2008-05-22
					/*
					DataResource curDN=((DataResource)DNSequence.get(i));
					ArrayList tbls=curDN.getDrMDDataResource().getTables();
					for(int j=0;j<v.size();j++){
						for(int k=0;k<tbls.size();k++){
							if(((MDTable)tbls.get(k)).getName().equals(tablename[j])){//??
								ArrayList cols=((MDTable)tbls.get(k)).getColumns();
								for(int kk=0;kk<cols.size();kk++){
									if(((MDField)cols.get(kk)).getucd().equals("pos.eq.ra;meta.main"))
										racol[i+j]=((MDField)cols.get(kk)).getname();
									if(((MDField)cols.get(kk)).getucd().equals("pos.eq.dec;meta.main"))
										deccol[i+j]=((MDField)cols.get(kk)).getname();
								}
							}
						}
					}*/
					//addec by LC 2008-05-22
					//modified by LC for adding automatic find coordinates field 2008-05-16
					searchConditionTree(sc, vector1, i, vDNCondi);

					DNCondi.add(vDNCondi);
				}

				// for each SearchCondition in last DNCondi
				Vector v = (Vector) DNCondi.get(DNCondi.size() - 1);
				for (int i = 0; i < v.size(); i++) {
					SearchCondition scondi = (SearchCondition) v.get(i);
					// System.out.println(scondi.getADQLString());
					if (!(scondi.getClass().getName().equals(
							"net.ivoa.adql.XMatch")
							|| scondi.getClass().getName().equals(
									"net.ivoa.adql.Region") || scondi
							.getClass().getName().equals(
									"net.ivoa.adql.TrueCond"))) {
						DBObject[] dbo = scondi.getAllDBObjects();
						for (int k = 0; k < dbo.length; k++) {
							String alias = dbo[k].getFirst().getADQLString();
							if (!vvAlias.contains(alias)) {
								vvAlias.add(alias);
								Vector ve = new Vector();
								ve.add(dbo[k].getSecond(0));
								vvColumns.add(ve);
							} else {
								int ialias = vvAlias.indexOf(alias);
								// System.out.println(ialias);
								Vector ve = new Vector();
								ve = (Vector) vvColumns.get(ialias);
								// System.out.println(((ADQLToken)ve.get(0)).getADQLString());
								// if(!ve.contains(dbo[k].getSecond(0)))
								ve.add(dbo[k].getSecond(0));
								vvColumns.remove(ialias);
								vvColumns.add(ialias, ve);
							}
						}
					}

				}

				// for each DN
				for (int i = 0; i < DNSequence.size(); i++) {
					Vector ve = new Vector();
					ve = (Vector) DNVectorMap.get(DNSequence.get(i));

					// for each Alias
					for (int j = 0; j < ve.size(); j++) {
						String tablename = this.getTableName(((DBObject) (ve
								.get(j))));
						Vector column = this
								.getColumns(((DBObject) (ve.get(j)))
										.getADQLString());
						Vector columns = new Vector();
						for (int m = 0; m < column.size(); m++) {
							columns.add(((ADQLToken) (column.get(m)))
									.getADQLString());
						}
						// if(!((DataResource)DNSequence.get(i)).checkDNColumns(tablename,columns))
						// {
						// daslog.error(0x00030005);
						// daslog.debug(ExceptionMessage.getExceptionMessage(ExceptionMessage.CheckDNColumnsException));
						// throw new CheckDNColumnsException();
						// }
					}
				}
				vvAlias.clear();
				vvColumns.clear();

			} 
			/*removed by LC 2008-05-07*/
			/*else if (hasImage) {

			} else if (hasSpec) {

			}*/
			/*removed by LC 2008-05-07*/
		}

	}

	void searchConditionTree(SearchCondition sc, Vector vector1, int i,
			Vector vDNCondi) throws TableItemNotFoundException,
			SearchConditionOutOfDNVectorErrorException,
			ContainsTableErrorException, DBObjectNotFoundException {

		if (sc.getClass().getName().equals("net.ivoa.adql.And")
				|| sc.getClass().getName().equals("net.ivoa.adql.Or")
				|| sc.getClass().getName().equals("net.ivoa.adql.Not")) {
			if (sc.getClass().getName().equals("net.ivoa.adql.And")) {
				searchConditionTree(((And) sc).getLeft(), vector1,i, vDNCondi);
				searchConditionTree(((And) sc).getRight(), vector1, i, vDNCondi);
			} else if (sc.getClass().getName().equals("net.ivoa.adql.Or")) {
				searchConditionTree(((Or) sc).getLeft(), vector1,i, vDNCondi);
				searchConditionTree(((Or) sc).getRight(), vector1, i, vDNCondi);
			} else {
				searchConditionTree(((Not) sc).getRight(), vector1,i, vDNCondi);
			}
		} else {
			if (sc.getClass().getName().equals("net.ivoa.adql.Region")) {
				if (i == 0) {
					vDNCondi.add(sc);
					dnAlias1 = ((DBObject) vector1.get(0)).getADQLString();
					//added by LC 2008-05-16
					/*DataResource curDN=((DataResource)DNSequence.get(i));
					ArrayList tbls=curDN.getDrMDDataResource().getTables();
					for(int j=0;j<tbls.size();j++){
						if(((MDTable)tbls.get(j)).getName().equals(tablename[i])){
							ArrayList cols=((MDTable)tbls.get(j)).getColumns();
							for(int kk=0;kk<cols.size();kk++){
								if(((MDField)cols.get(kk)).getucd().equals("pos.eq.ra;meta.main"))
									racol=((MDField)cols.get(kk)).getname();
								if(((MDField)cols.get(kk)).getucd().equals("pos.eq.dec;meta.main"))
									deccol=((MDField)cols.get(kk)).getname();
							}
						}
					}*/
					//added by LC 2008-05-16
				} else
					vDNCondi.add(new TrueCond());

			} else if (sc.getClass().getSuperclass().getName().equals(
					"net.ivoa.adql.Predicate")) {
				int ct = sc.containsTables(vector1);
				if ((i == DNSequence.size() - 1) && (ct != 1)) {
					daslog.error(0x00030013);
					daslog
							.debug(ExceptionMessage
									.getExceptionMessage(ExceptionMessage.SearchConditionOutOfDNVector_Error));
					throw new SearchConditionOutOfDNVectorErrorException();
				}
				// System.out.println("predicate:"+ct);
				if (ct == 1) {
					vDNCondi.add(sc);

				} else if (ct == 2) {
					vDNCondi.add(new TrueCond());
					DBObject[] dbo = sc.getAllDBObjects();
					for (int j = 0; j < dbo.length; j++) {
						if (vector1.contains(dbo[j].getFirst())) {
							Vector ve = (Vector) DNCol.get(i);
							ve.add(new Column(dbo[j]));
							DNCol.remove(i);
							DNCol.add(i, ve);
						}
					}

				} else if (ct == 0) {
					vDNCondi.add(new TrueCond());
				} else // ct==3
				{
					daslog.error(0x00030012);
					daslog
							.debug(ExceptionMessage
									.getExceptionMessage(ExceptionMessage.ContainsTable_Error));
					throw new ContainsTableErrorException();
				}

			} else if (sc.getClass().getName().equals("net.ivoa.adql.XMatch")) {
				// System.out.println("XMatch:"+((XMatch)sc).getADQLString());
				Vector xlist = ((XMatch) sc).getXAliasList();
				rade_xmatch = (String) xlist.get(0);
				Vector xmatch = new Vector();
				for (int x = 0; x < xlist.size(); x++) {
					for (int y = 0; y < vector1.size(); y++) {
						if (((DBObject) vector1.get(y)).getADQLString().equals(
								(String) xlist.get(x)))
							xmatch.add((String) xlist.get(x));
					}

				}

				// if(xmatch.size()==xlist.size())
				// {
				// vDNCondi.add(sc);
				// }
				// if(xmatch.size()==2)
				// {
				// SearchCondition scx = new XMatch();
				// ((XMatch)scx).setXAliasList(xmatch);
				// ((XMatch)scx).setSigma(((XMatch)sc).getSigma());
				//					
				// vDNCondi.add(scx);
				// }
				if (xmatch.size() >= 2) {

					Vector v = new Vector();
					v = (Vector) DNVectorMap.get(DNSequence.get(i));
					// System.out.println(((DBObject)v.get(0)).getADQLString());
					boolean ifmatch = false;
					for (int x = 0; x < xlist.size(); x++) {
						if (((DBObject) v.get(0)).getADQLString().equals(
								xlist.get(x))) {
							SearchCondition scx = new XMatch();
							Vector xtable = new Vector();
							xtable.add("up");
							xtable.add((String) xlist.get(x));
							// System.out.println(x);
							// System.out.println((String)xlist.get(x));
							((XMatch) scx).setXAliasList(xtable);
							((XMatch) scx).setSigma(((XMatch) sc).getSigma());

							vDNCondi.add(scx);
							ifmatch = true;

						}

					}
					if (!ifmatch)
						vDNCondi.add(new TrueCond());

				} else if (xmatch.size() < 2) {
					vDNCondi.add(new TrueCond());
				}

			}

		}
	}

	void buildActivityRequest() throws JoinedTableErrorException,
			TableItemNotFoundException, SearchConditionErrorException,
			DBObjectNotFoundException, DataNodePerformException,
			ServiceCommsException, MalformedURLException, ServerException,
			ResourceUnknownException, AuthorisationException,
			ResourceBusyException, RequestException, InterruptedException,
			DataFormatException,GetTableTypeException {
		/*if (hasCatalogue)*/ {//removed by LC 2008-05-07
			// from vsqlfrom
			buildFrom();
			buildSelect();
			buildWhere();
			for (int i = 0; i < vsql.size(); i++) {
				System.out.println("sql:" + (String) vsql.get(i));
				Vector vardn = new Vector();
				vardn.add((DataResource) DNSequence.get(i));
				vardn.add((String) vsql.get(i));
				arDN.add(vardn);
			}

			// runNextDN(0);

		}
		/*removed by LC 2008-05-07*/
		/*else if (hasImage) {

		} else if (hasSpec) {

		}*/
		/*removed by LC 2008-05-07*/
	}

	void buildWhere() throws TableItemNotFoundException,
			SearchConditionErrorException, DBObjectNotFoundException {
		if (ss.getWhere() != null) {
			for (int i = 0; i < DNSequence.size(); i++) {
				String sqlwhere = "Where ";
				Vector vector = (Vector) DNCondi.get(i);
				// tree
				Where w = ss.getWhere();
				SearchCondition sc = w.getSearchCondition();

				tree = searchConditionTree(sc, vector, i);

				treecount = -1;

				 System.out.println("tree:"+tree);
				sqlwhere += tree;

				daslog.debug("sqlwhere:" + sqlwhere);
				String str = (String) vsql.get(i);
				str = str + sqlwhere;
				vsql.remove(i);
				vsql.add(i, str);

			}

		}
	}

	String searchConditionTree(SearchCondition sc, Vector vector, int i)//i represent the index in DNSequence
			throws TableItemNotFoundException, DBObjectNotFoundException,
			SearchConditionErrorException {
		if (sc.getClass().getName().equals("net.ivoa.adql.And")
				|| sc.getClass().getName().equals("net.ivoa.adql.Or")
				|| sc.getClass().getName().equals("net.ivoa.adql.Not")) {
			if (sc.getClass().getName().equals("net.ivoa.adql.And")) {
				String left = searchConditionTree(((And) sc).getLeft(), vector,
						i);
				String right = searchConditionTree(((And) sc).getRight(),
						vector, i);
				tree = " ( " + left + " ) AND ( " + right + " ) ";
				return tree;
			} else if (sc.getClass().getName().equals("net.ivoa.adql.Or")) {
				String left = searchConditionTree(((Or) sc).getLeft(), vector,
						i);
				String right = searchConditionTree(((Or) sc).getRight(),
						vector, i);
				tree = " ( " + left + " ) Or ( " + right + " ) ";
				return tree;
			} else {
				String right = searchConditionTree(((Not) sc).getRight(),
						vector, i);
				tree = " Not ( " + right + " ) ";
				return tree;
			}
		} else {
			treecount++;
			// System.out.println(treecount);
			return addSearchCondi(i, treecount, vector);

		}
	}

	String addSearchCondi(int i, int j, Vector vector)
			throws TableItemNotFoundException, DBObjectNotFoundException,
			SearchConditionErrorException {
		String str = new String();
		if (((SearchCondition) vector.get(j)).getClass().getName().equals(
				"net.ivoa.adql.TrueCond")) {
			str = ((TrueCond) vector.get(j)).getADQLString();
		} else if (((SearchCondition) vector.get(j)).getClass().getName()
				.equals("net.ivoa.adql.CompareOp")) {
			if (i != 0) {
				// DBObject[] dbo =
				// ((SearchCondition)vector.get(j)).getAllDBObjectsWithoutCurrDN((Vector)DNVectorMap.get(DNSequence.get(i)));
				// for(int k=0;k<dbo.length;k++)
				// {
				// dbo[k].rename("up");
				// }
				((CompareOp) vector.get(j)).replaceName(((DBObject) vAlias
						.get(i - 1)).getADQLString(), "up");
			}

			str = ((CompareOp) vector.get(j)).getADQLString();// ?

		} else if (((SearchCondition) vector.get(j)).getClass().getName()
				.equals("net.ivoa.adql.Region")) {
//modified by LC 2008-05-16
			/*let ra,dec be found automatically*/
			String racol = "";
			String deccol = "";
			DataResource curDN=((DataResource)DNSequence.get(i));
			ArrayList tbls=curDN.getDrMDDataResource().getTables();//all available tables in current datanode
			//Vector tbls2=(Vector)DNVectorMap.get(curDN);//used tables in this select satement
			
			for(int jj=0;jj<tbls.size();jj++){
				String tbname1=((MDTable)tbls.get(jj)).getName();
				for(int ii=0;ii<vDBObject.size();ii++){
					DBObject tb=(DBObject)(vDBObject.get(ii));
					String tbname2=tb.getADQLString();
					if(tbname1.equals(tbname2)){//if the using table matches an available one
						ArrayList cols=((MDTable)tbls.get(jj)).getColumns();
						for(int kk=0;kk<cols.size();kk++){
							if(((MDField)cols.get(kk)).getucd().equals("pos.eq.ra;meta.main"))
								racol=((MDField)cols.get(kk)).getname();
							if(((MDField)cols.get(kk)).getucd().equals("pos.eq.dec;meta.main"))
								deccol=((MDField)cols.get(kk)).getname();
						}
					}
				}
			}
			
			
			//str = ((Region) vector.get(j)).getADQLString();// ?
			
			double ra = ((Region) vector.get(j)).regparams[0];
			double dec = ((Region) vector.get(j)).regparams[1];
			double sigma = ((Region) vector.get(j)).regparams[2];
			str = sigma + "*" + sigma + ">=(" + dnAlias1 + "."+racol + "-" + ra
			+ ")*cos((" +  dec + ")*3.14/180/2)*("
			+ dnAlias1 + "."+racol + "-" + ra + ")*cos((" + dec + ")*3.14/180/2)+" + "(" + dnAlias1
			+ "."+deccol + "-" + dec + ")*(" + dnAlias1 + "."+deccol + "-"
			+ dec + ")";
			/*
			 str = sigma + "*" + sigma + ">=(" + dnAlias1 + ".ra" + "-" + ra
					+ ")*cos((" + dnAlias1 + ".decl+" + dec + ")*3.14/180/2)*("
					+ dnAlias1 + ".ra" + "-" + ra + ")*cos((" + dnAlias1
					+ ".decl+" + dec + ")*3.14/180/2)+" + "(" + dnAlias1
					+ ".decl" + "-" + dec + ")*(" + dnAlias1 + ".decl" + "-"
					+ dec + ")";
					*/
//modified by LC 2008-05-16
		} else if (((SearchCondition) vector.get(j)).getClass().getName()
				.equals("net.ivoa.adql.XMatch")) {
			// System.out.println(((DBObject)(((Vector)DNVectorMap.get(DNSequence.get(0))).get(0))).getADQLString());
			// String
			// old=((DBObject)(((Vector)DNVectorMap.get(DNSequence.get(0))).get(0))).getADQLString();
			// ((XMatch)vector.get(j)).replaceName(old,"up");
			// str = ((XMatch) vector.get(j)).getADQLString();// ?
			// System.out.println(str);
			String t1 = (String) (((XMatch) vector.get(j)).getXAliasList()
					.get(0));
			String t2 = (String) (((XMatch) vector.get(j)).getXAliasList()
					.get(1));
//			modified by LC 2008-05-16
			/*let ra,dec be found automatically*/
			String racol = "";
			String deccol = "";
			String racolpre = "";
			String deccolpre = "";
			DataResource curDN=((DataResource)DNSequence.get(i));
			ArrayList tbls=curDN.getDrMDDataResource().getTables();//all available tables in current datanode
			//Vector tbls2=(Vector)DNVectorMap.get(curDN);//used tables in this select satement
			
			for(int jj=0;jj<tbls.size();jj++){
				String tbname1=((MDTable)tbls.get(jj)).getName();
				for(int ii=0;ii<vDBObject.size();ii++){
					DBObject tb=(DBObject)(vDBObject.get(ii));
					String tbname2=tb.getADQLString();
					if(tbname1.equals(tbname2)){//if the using table matches an available one
						ArrayList cols=((MDTable)tbls.get(jj)).getColumns();
						for(int kk=0;kk<cols.size();kk++){
							if(((MDField)cols.get(kk)).getucd().equals("pos.eq.ra;meta.main"))
								racol=((MDField)cols.get(kk)).getname();
							if(((MDField)cols.get(kk)).getucd().equals("pos.eq.dec;meta.main"))
								deccol=((MDField)cols.get(kk)).getname();
						}
					}
				}
			}
			DataResource preDN=((DataResource)DNSequence.get(i-1));
			tbls=preDN.getDrMDDataResource().getTables();//all available tables in current datanode
			//Vector tbls2=(Vector)DNVectorMap.get(curDN);//used tables in this select satement
			
			for(int jj=0;jj<tbls.size();jj++){
				String tbname1=((MDTable)tbls.get(jj)).getName();
				for(int ii=0;ii<vDBObject.size();ii++){
					DBObject tb=(DBObject)(vDBObject.get(ii));
					String tbname2=tb.getADQLString();
					if(tbname1.equals(tbname2)){//if the using table matches an available one
						ArrayList cols=((MDTable)tbls.get(jj)).getColumns();
						for(int kk=0;kk<cols.size();kk++){
							if(((MDField)cols.get(kk)).getucd().equals("pos.eq.ra;meta.main"))
								racolpre=((MDField)cols.get(kk)).getname();
							if(((MDField)cols.get(kk)).getucd().equals("pos.eq.dec;meta.main"))
								deccolpre=((MDField)cols.get(kk)).getname();
						}
					}
				}
			}
			
			double sigma = ((XMatch) vector.get(j)).getSigma();
			str = sigma + "*" + sigma + "/1200/1200>=((" + t1 + "."+racolpre+"_"
			+ rade_xmatch + "-" + t2 + "."+racol+")*" + "cos((" + t1
			+ "."+deccolpre+"_" + rade_xmatch + "+" + t2
			+ "."+deccol+")*3.1415927/180/2)*(" + t1 + "."+racolpre+"_" + rade_xmatch + "-"
			+ t2 + "."+racol+")*" + "cos((" + t1 + "."+deccolpre+"_" + rade_xmatch
			+ "+" + t2 + "."+deccol+")*3.1415927/180/2)+(" + t1 + "."+deccolpre+"_"
			+ rade_xmatch + "-" + t2 + "."+deccol+")*" + "(" + t1 + "."+deccolpre+"_"
			+ rade_xmatch + "-" + t2 + "."+deccol+"))";
			/*
			str = sigma + "*" + sigma + "/1200/1200>=((" + t1 + ".ra_"
					+ rade_xmatch + "-" + t2 + ".ra)*" + "cos((" + t1
					+ ".decl_" + rade_xmatch + "+" + t2
					+ ".decl)*3.14/180/2)*(" + t1 + ".ra_" + rade_xmatch + "-"
					+ t2 + ".ra)*" + "cos((" + t1 + ".decl_" + rade_xmatch
					+ "+" + t2 + ".decl)*3.14/180/2)+(" + t1 + ".decl_"
					+ rade_xmatch + "-" + t2 + ".decl)*" + "(" + t1 + ".decl_"
					+ rade_xmatch + "-" + t2 + ".decl))";
					*/
//			modified by LC 2008-05-16
			
		} else {
			daslog.error(0x00030017);
			daslog
					.debug(ExceptionMessage
							.getExceptionMessage(ExceptionMessage.SearchCondition_Error));
			throw new SearchConditionErrorException();
		}
		return str;
	}

	void buildSelect() throws TableItemNotFoundException,
			DBObjectNotFoundException,GetTableTypeException {

		// getTop();
		// getDinstinct();
		Vector vector2 = new Vector();
		for (int i = 0; i < DNSequence.size(); i++) {
			String sqlselect = "SELECT ";
			Vector vector = (Vector) DNCol.get(i);//column list with respect to the current DN
			/*added by LC 2008-05-07*/
			DataResource curDN=(DataResource)DNSequence.get(i);
			/*added by LC 2008-05-07*/
			Vector v = new Vector();
			v = (Vector) DNVectorMap.get(curDN);//refered table in the current DN
			
			// get column name for create upload table
			Vector cn = new Vector();

			for (int j = 0; j < vector.size(); j++) {
				// System.out.println("Column:"+((Column)vector.get(j)).getADQLString());
				if (i != 0) {
					// DBObject[] dbo =
					// ((Column)vector.get(j)).getAllDBObjectsWithoutCurrDN((Vector)DNVectorMap.get(DNSequence.get(i)));
					// // System.out.println(dbo.length);
					// for(int k=0;k<dbo.length;k++)
					// {
					//					    	
					// dbo[k].replaceName((dbo[k].getFirst()).getADQLString(),"up");
					// // System.out.println(dbo[k].getFirst().getADQLString());
					// }
					int ct = ((Column) vector.get(j)).containsTables(vector2);
					// for(int k=0;k<vector2.size();k++)
					// System.out.println("vector2:"+((DBObject)vector2.get(k)).getADQLString());
					// System.out.println(ct);
					if (ct == 1)
						((Column) vector.get(j)).replaceAlias(
								((DBObject) vAlias.get(i - 1)).getADQLString(),
								"up");
					else
						((Column) vector.get(j)).replaceName(((DBObject) vAlias
								.get(i - 1)).getADQLString(), "up");
					
				}
				String colstring=((Column) vector.get(j)).getADQLString();
				
				if (j == 0)
					sqlselect += colstring + " ";
				else
					sqlselect += "," + colstring+ " ";

				if (!((Column) vector.get(j)).getADQLString().trim().substring(
						0, 2).equals("up"))
					cn.add(((Column) vector.get(j)).getADQLString().substring(
							((Column) vector.get(j)).getADQLString().indexOf(
									".") + 1)
							+ "_"
							+ ((Column) vector.get(j)).getADQLString()
									.substring(
											0,
											((Column) vector.get(j))
													.getADQLString().indexOf(
															".")));
			}
			/*added by LC 2008-05-07*/
			if(curDN.getTableType()==3){//is spectra table and path column
				//String rooturl=curDN.getDrMDDataResource().getCuration().getPublisherreferenceurl();
				String rooturl=curDN.getDrMDDataResource().getGeneralcontent().getReferenceURL();
				for(int k=0;k<v.size();k++){
					DBObject dbtable=(DBObject)v.get(k);
					String tablename=getTableName(dbtable);
					String pathname=dbtable.getADQLString()+"."+curDN.getDrMDDataResource().getSpecFilePathColumn(tablename);
					
					if(sqlselect.length()>7){
						sqlselect+=", CONCAT('"+rooturl+"',"+pathname+") as spfileurl_"+i+"_"+k+" ";
					}
					else{
						sqlselect+="  CONCAT('"+rooturl+"',"+pathname+") as spfileurl_"+i+"_"+k+" ";
					}
				}
				
			}
			/*added by LC 2008-05-07*/
			if(i!=0){
				
				DataResource preDN=(DataResource)DNSequence.get(i-1);
				if(preDN.getTableType()==3){//is spectra table and path column
					//String rooturl=preDN.getDrMDDataResource().getCuration().getPublisherreferenceurl();
					String rooturl=curDN.getDrMDDataResource().getGeneralcontent().getReferenceURL();
					Vector pv=(Vector) DNVectorMap.get(preDN);
					for(int k=0;k<pv.size();k++){
						if(sqlselect.length()>7){
							sqlselect+=", up.spfileurl_"+(i-1)+"_"+k+" ";
						}
						else{
							sqlselect+="  up.spfileurl_"+(i-1)+"_"+k+" ";
						}
					}
					
				}
				/*added by LC 2008-05-07*/
			}
			for (int j = 0; j < v.size(); j++) {
				vector2.add(v.get(j));
			}

			
			daslog.debug("sqlselect:" + sqlselect);
			String str = (String) vsql.get(i);
			str = sqlselect + str;
			vsql.remove(i);			
			vsql.add(i, str);
			if (i > 0) {
				Vector cntemp = (Vector) columnnames.get(i - 1);
				for (int j = 0; j < cntemp.size(); j++) {
					cn.add(cntemp.get(j));
				}
			}

			columnnames.add(cn);
			// System.out.println("select:"+sqlselect);
		}
		
		
	}

	void buildFrom() throws JoinedTableErrorException {
		if (hasJoinedTable) {

			Vector ve1 = (Vector) DNVectorMap.get((DataResource) DNSequence
					.get(0));

			if (ve1.contains(joinedTableAlias.get(0))
					&& ve1.contains(joinedTableAlias.get(1))) {
				String sqlfrom = "FROM ";
				for (int j = 0; j < ve1.indexOf(joinedTableAlias.get(0)); j++) {
					if (j == 0)
						sqlfrom += getTableName((DBObject) ve1.get(j)) + " "
								+ ((DBObject) ve1.get(j)).getADQLString() + " ";
					else
						sqlfrom += ", " + getTableName((DBObject) ve1.get(j))
								+ " " + ((DBObject) ve1.get(j)).getADQLString()
								+ " ";

				}

				if (ve1.indexOf(joinedTableAlias.get(0)) == 0) {
					sqlfrom += getTableName((DBObject) ve1.get(ve1
							.indexOf(joinedTableAlias.get(0))))
							+ " "
							+ ((DBObject) ve1.get(ve1.indexOf(joinedTableAlias
									.get(0)))).getADQLString() + " ";
					if (jointype == 1)
						sqlfrom += "Join Type "
								+ getTableName((DBObject) ve1.get(ve1
										.indexOf(joinedTableAlias.get(1))))
								+ " "
								+ ((DBObject) ve1.get(ve1
										.indexOf(joinedTableAlias.get(1))))
										.getADQLString() + " ";
					else if (jointype == 2)
						;
					// ...
				} else {
					sqlfrom += ", "
							+ getTableName((DBObject) ve1.get(ve1
									.indexOf(joinedTableAlias.get(0))))
							+ " "
							+ ((DBObject) ve1.get(ve1.indexOf(joinedTableAlias
									.get(0)))).getADQLString() + " ";
					if (jointype == 1)
						sqlfrom += "Join Type "
								+ getTableName((DBObject) ve1.get(ve1
										.indexOf(joinedTableAlias.get(1))))
								+ " "
								+ ((DBObject) ve1.get(ve1
										.indexOf(joinedTableAlias.get(1))))
										.getADQLString() + " ";
					else if (jointype == 2)
						;
					// ...
				}

				for (int j = ve1.indexOf(joinedTableAlias.get(0)) + 2; j < ve1
						.size(); j++) {
					sqlfrom += ", " + getTableName((DBObject) ve1.get(j)) + " "
							+ ((DBObject) ve1.get(j)).getADQLString() + " ";

				}
				daslog.debug("sqlfrom:" + sqlfrom);
				vsql.add(sqlfrom);

				sqlfrom = "FROM ";
				for (int i = 1; i < DNSequence.size(); i++) {
					Vector ve = (Vector) DNVectorMap
							.get((DataResource) DNSequence.get(i));

					sqlfrom += "uploadName" + " up ";

					for (int j = 0; j < ve.size(); j++) {

						sqlfrom += ", " + getTableName((DBObject) ve.get(j))
								+ " " + ((DBObject) ve.get(j)).getADQLString()
								+ " ";
					}
					daslog.debug("sqlfrom:" + sqlfrom);
					vsql.add(sqlfrom);
				}

			} else if (DNSequence.size() > 1) {
				Vector ve2 = (Vector) DNVectorMap.get((DataResource) DNSequence
						.get(1));
				if (ve1.contains(joinedTableAlias.get(0)) && ve1.size() == 1
						&& ve2.contains(joinedTableAlias.get(1))
						&& ve2.indexOf(joinedTableAlias.get(1)) == 0) {
					String sqlfrom = "FROM ";
					sqlfrom += getTableName((DBObject) ve1.get(0)) + " "
							+ ((DBObject) ve1.get(0)).getADQLString() + " ";
					daslog.debug("sqlfrom:" + sqlfrom);
					vsql.add(sqlfrom);

					sqlfrom = "FROM ";
					sqlfrom += "uploadName" + " up ";
					if (jointype == 1)
						sqlfrom += "Join Type "
								+ getTableName((DBObject) ve2.get(ve2
										.indexOf(joinedTableAlias.get(1))))
								+ " "
								+ ((DBObject) ve2.get(ve2
										.indexOf(joinedTableAlias.get(1))))
										.getADQLString() + " ";
					else if (jointype == 2)
						;
					// ...

					for (int j = 1; j < ve1.size(); j++) {
						sqlfrom += ", " + getTableName((DBObject) ve1.get(j))
								+ " " + ((DBObject) ve1.get(j)).getADQLString()
								+ " ";
					}
					daslog.debug("sqlfrom:" + sqlfrom);
					vsql.add(sqlfrom);

					for (int i = 2; i < DNSequence.size(); i++) {
						sqlfrom = "FROM ";
						Vector ve = (Vector) DNVectorMap
								.get((DataResource) DNSequence.get(i));

						sqlfrom += "uploadName" + " up ";

						for (int j = 0; j < ve.size(); j++) {

							sqlfrom += ", "
									+ getTableName((DBObject) ve.get(j)) + " "
									+ ((DBObject) ve.get(j)).getADQLString()
									+ " ";
						}
						daslog.debug("sqlfrom:" + sqlfrom);
						vsql.add(sqlfrom);
					}

				} else {
					daslog.error(0x00030015);
					daslog
							.debug(ExceptionMessage
									.getExceptionMessage(ExceptionMessage.JoinedTable_Error));
					throw new JoinedTableErrorException();
				}
			} else {
				daslog.error(0x00030015);
				daslog
						.debug(ExceptionMessage
								.getExceptionMessage(ExceptionMessage.JoinedTable_Error));
				throw new JoinedTableErrorException();
			}
		} else {

			for (int i = 0; i < DNSequence.size(); i++) {
				Vector ve = (Vector) DNVectorMap.get((DataResource) DNSequence
						.get(i));
				String sqlfrom = "FROM ";
				if (i != 0)
					sqlfrom += "uploadName" + " up ";

				// get table name for create upload table
				Vector tn = new Vector();

				for (int j = 0; j < ve.size(); j++) {
					if (j == 0 && i == 0)
						sqlfrom += getTableName((DBObject) ve.get(j)) + " "
								+ ((DBObject) ve.get(j)).getADQLString() + " ";
					else
						sqlfrom += ", " + getTableName((DBObject) ve.get(j))
								+ " " + ((DBObject) ve.get(j)).getADQLString()
								+ " ";

					tn.add(getTableName((DBObject) ve.get(j)));
				}
				daslog.debug("sqlfrom:" + sqlfrom);
				vsql.add(sqlfrom);
				tablenames.add(tn);
				// System.out.println("From:"+sqlfrom);
			}

		}
	}

	public void runNextDN(int i) throws DataFormatException,
			DataNodePerformException, ServiceCommsException,
			MalformedURLException, ServerException, ResourceUnknownException,
			AuthorisationException, ResourceBusyException, RequestException,
			InterruptedException {
		// System.out.println("run");
		if (arDN.size() == 1) {
			Vector varDN = (Vector) arDN.get(i);

			DataResource dr = (DataResource) varDN.get(0);

			String sqlquery = (String) varDN.get(1);

			SQLQuery query = new SQLQuery(sqlquery);
			
			/////////////////////////csv with comma
			if (this.format == 0) { //format =0 ====>csv with comma
				CSV csv = new CSV(query.getOutput());
				CSVConfigurator csvconf = new CSVConfigurator();
				csvconf.setMIncludeHeader(true);
				csvconf.setMEscapeFields(false);
				csv.setConfigurator(csvconf);

				ActivityRequest request = new ActivityRequest();
				request.add(query);
				// request.add( rowset );
				request.add(csv);
				if (!(targetURL.equals(""))) {
					DeliverToURL dtu = new DeliverToURL(this.targetURL, csv
							.getOutput());
					request.add(dtu);
				}
				Response response = dr.perform(request);
				this.session = response.getSession();

				if (targetURL.equals("")) {
					this.queryresult = response.getAsString();
					//System.out.println("queryresult:" + queryresult);
				}
			}

			/////////////////////////csv with tab
			
			else if (this.format == 1) { //format = 1 ====>csv with tab
				CSV csv = new CSV(query.getOutput());
				CSVConfigurator csvconf = new CSVConfigurator();
				csvconf.setMIncludeHeader(true);
				csvconf.setMEscapeFields(false);
				try {
					csvconf.setMDelimiter("\t");
				} catch (CSVConfigurationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				csv.setConfigurator(csvconf);

				ActivityRequest request = new ActivityRequest();
				request.add(query);
				// request.add( rowset );
				request.add(csv);
				if (!(targetURL.equals(""))) {
					DeliverToURL dtu = new DeliverToURL(this.targetURL, csv
							.getOutput());
					request.add(dtu);
				}
				Response response = dr.perform(request);
				this.session = response.getSession();
				
				if (targetURL.equals("")) {	
					
					this.queryresult = response.getAsString();
					//System.out.println("queryresult:" + queryresult);
				}
			}
			
			
			/////////////////////////votable
			else if (this.format == 2) { //format = 2 ====>votable
				SQLResult2VOTableClient sql2votable = new SQLResult2VOTableClient(query.getOutput());

				ActivityRequest request = new ActivityRequest();
				request.add(query);
				// request.add( rowset );
				request.add(sql2votable);
				if (!(targetURL.equals(""))) {
					DeliverToURL dtu = new DeliverToURL(this.targetURL, sql2votable
							.getOutput());
					request.add(dtu);
				}
				Response response = dr.perform(request);
				this.session = response.getSession();

				if (targetURL.equals("")) {
					this.queryresult = response.getAsString();
					//System.out.println("queryresult:" + queryresult);
				}
			}
			

		} else {

			if (i == 0) {
				Vector varDN = (Vector) arDN.get(i);

				DataResource dr = (DataResource) varDN.get(0);

				String sqlquery = (String) varDN.get(1);

				SQLQuery query = new SQLQuery(sqlquery);
				// SQLQuery query = new SQLQuery("select s.ra , s.decl from
				// DAItest.sdss s ");

				WebRowSet rowset = new WebRowSet(query.getOutput());
				// CSV csv = new CSV(query.getOutput());

				DTOutputStream outputStream = new DTOutputStream();
				outputStream.setInput(rowset.getOutput());

				// DeliverToURL dtu = new
				// DeliverToURL("ftp://naoc:astronomy@info.bao.ac.cn/pub/incoming/gd/test.dat",rowset.getOutput());

				ActivityRequest sourcerequest = new ActivityRequest();
				sourcerequest.add(query);
				sourcerequest.add(rowset);

				sourcerequest.add(outputStream);
				sourcerequest.setSessionRequirements(new JoinNewSession());

				Response response = dr.perform(sourcerequest);
				this.session = response.getSession();

				// get column type
				Vector tn = ((Vector) (tablenames.get(i)));
				Vector cn = ((Vector) (columnnames.get(i)));
				ArrayList tables = new ArrayList(dr.getDrMDDataResource()
						.getTables());
				ArrayList columns = new ArrayList();
				Vector colnames = new Vector();
				Vector coltypes = new Vector();
				Vector colwidths = new Vector();
				Vector colprecis = new Vector();
				System.out.println("tn:" + tn.size());
				System.out.println("cn:" + cn.size());
				System.out.println("tables:" + tables.size());

				for (int j = 0; j < tn.size(); j++) {
					System.out.println("tnname:" + (String) tn.get(j));
					for (int k = 0; k < tables.size(); k++) {
						System.out.println("tablename:"
								+ ((MDTable) (tables.get(k))).getName());
						if (((MDTable) (tables.get(k))).getName().equals(
								(String) tn.get(j)))
							columns = ((MDTable) (tables.get(k))).getColumns();
					}
					System.out.println("columns:" + columns.size());
				}
				for (int j = 0; j < cn.size(); j++) {
					System.out.println("cnname:" + (String) cn.get(j));
					for (int k = 0; k < columns.size(); k++) {
						System.out.println("columnname:"
								+ ((MDField) (columns.get(k))).getname());
						if (((MDField) (columns.get(k))).getname().equals(
								((String) cn.get(j)).substring(0, ((String) cn
										.get(j)).indexOf("_")))) {
							colnames
									.add(((MDField) (columns.get(k))).getname());
							coltypes.add(((MDField) (columns.get(k)))
									.getdatatype());
							colwidths.add(((MDField) (columns.get(k)))
									.getWidth());
							colprecis.add(((MDField) (columns.get(k)))
									.getPrecision());
						}
					}
				}
				System.out.println("colnames:" + colnames.size());

				varDN = (Vector) arDN.get(i + 1);

				dr = (DataResource) varDN.get(0);

				DeliverFromDT deliverFromDT = new DeliverFromDT();
				deliverFromDT.setDataTransportInput(outputStream
						.getDataTransport());
				deliverFromDT.setDataTransportMode(DataTransportMode.BLOCK);
				ActivityRequest sinkrequest = new ActivityRequest();
				sinkrequest.add(deliverFromDT);

				String dropTable = "drop table if exists uploadName";
				SQLUpdate drop = new SQLUpdate(dropTable);
				sinkrequest.add(drop);

				// create table and bulkload
				String createTable = "create table if not exists uploadName (";
				// createTable+="ra_s double(10,6),decl_s double(10,6)";
				for (int j = 0; j < colnames.size(); j++) {
					if (j == 0)
						createTable += (String) cn.get(j) + " "
								+ (String) coltypes.get(j) + "("
								+ (String) colwidths.get(j) + ","
								+ (String) colprecis.get(j) + ")";
					else
						createTable += "," + (String) cn.get(j) + " "
								+ (String) coltypes.get(j) + "("
								+ (String) colwidths.get(j) + ","
								+ (String) colprecis.get(j) + ")";
				}
				createTable += ")";

				System.out.println(createTable);

				SQLUpdate create = new SQLUpdate(createTable);
				SQLBulkLoad bulkLoad = new SQLBulkLoad(deliverFromDT
						.getOutput(), "uploadName");

				sinkrequest.add(create);
				sinkrequest.add(bulkLoad);

				response = dr.perform(sinkrequest);
				this.session = response.getSession();
				System.out.println(response.getAsString());

			} else if (i == (arDN.size() - 1)) {
				Vector varDN = (Vector) arDN.get(i);

				DataResource dr = (DataResource) varDN.get(0);

				String sqlquery = (String) varDN.get(1);

				SQLQuery query = new SQLQuery(sqlquery);
				// SQLQuery query = new SQLQuery("select s.ra , s.decl from
				// DAItest.sdss s ");

				// WebRowSet rowset = new WebRowSet( query.getOutput() );
				CSV csv = new CSV(query.getOutput());
				CSVConfigurator csvconf = new CSVConfigurator();
				csvconf.setMIncludeHeader(true);
				csv.setConfigurator(csvconf);
				// DeliverToURL dtu = new
				// DeliverToURL("ftp://naoc:astronomy@info.bao.ac.cn/pub/incoming/tian/result2.dat",csv.getOutput());

				// DeliverToURL dtu = new
				// DeliverToURL("ftp://naoc:astronomy@info.bao.ac.cn/pub/incoming/gd/test.dat",rowset.getOutput());

				ActivityRequest sourcerequest = new ActivityRequest();
				sourcerequest.add(query);
				sourcerequest.add(csv);

				if (!(targetURL.equals(""))) {
					DeliverToURL dtu = new DeliverToURL(this.targetURL, csv
							.getOutput());
					sourcerequest.add(dtu);
				}

				Response response = dr.perform(sourcerequest);
				this.session = response.getSession();
				// System.out.println(response.getAsString());

				if (targetURL.equals("")) {
					queryresult = new String(response.getAsString());
					System.out.println(queryresult);
				}

				String dropTable = "drop table if exists uploadName";
				SQLUpdate drop = new SQLUpdate(dropTable);
				sourcerequest.add(drop);

			} else {

				Vector varDN = (Vector) arDN.get(i);

				DataResource dr = (DataResource) varDN.get(0);

				String sqlquery = (String) varDN.get(1);

				SQLQuery query = new SQLQuery(sqlquery);
				// SQLQuery query = new SQLQuery("select s.ra , s.decl from
				// DAItest.sdss s ");

				WebRowSet rowset = new WebRowSet( query.getOutput() );
//				CSV csv = new CSV(query.getOutput());

				DTOutputStream outputStream = new DTOutputStream();
//				outputStream.setInput(csv.getOutput());
				outputStream.setInput(rowset.getOutput());

				// DeliverToURL dtu = new
				// DeliverToURL("ftp://naoc:astronomy@info.bao.ac.cn/pub/incoming/gd/test.dat",rowset.getOutput());

				ActivityRequest sourcerequest = new ActivityRequest();
				sourcerequest.add(query);
//				sourcerequest.add(csv);
				// request.add( csv );
				sourcerequest.add(rowset);

				sourcerequest.add(outputStream);

				Response response = dr.perform(sourcerequest);
				this.session = response.getSession();

				String dropTable = "drop table uploadName if exists";
				SQLUpdate drop = new SQLUpdate(dropTable);
				sourcerequest.add(drop);

				// get column type
				Vector tn = ((Vector) (tablenames.get(i)));
				Vector cn = ((Vector) (columnnames.get(i)));
				ArrayList tables = new ArrayList(dr.getDrMDDataResource()
						.getTables());
				ArrayList columns = new ArrayList();
				Vector colnames = new Vector();
				Vector coltypes = new Vector();
				Vector colwidths = new Vector();
				Vector colprecis = new Vector();
				System.out.println("tn:" + tn.size());
				System.out.println("cn:" + cn.size());
				System.out.println("tables:" + tables.size());

				for (int j = 0; j < tn.size(); j++) {
					System.out.println("tnname:" + (String) tn.get(j));
					for (int k = 0; k < tables.size(); k++) {
						System.out.println("tablename:"
								+ ((MDTable) (tables.get(k))).getName());
						if (((MDTable) (tables.get(k))).getName().equals(
								(String) tn.get(j)))
							columns = ((MDTable) (tables.get(k))).getColumns();
					}
					System.out.println("columns:" + columns.size());
				}
				for (int j = 0; j < cn.size(); j++) {
					System.out.println("cnname:" + (String) cn.get(j));
					for (int k = 0; k < columns.size(); k++) {
						System.out.println("columnname:"
								+ ((MDField) (columns.get(k))).getname());
						if (((MDField) (columns.get(k))).getname().equals(
								((String) cn.get(j)).substring(0, ((String) cn
										.get(j)).indexOf("_")))) {
							colnames
									.add(((MDField) (columns.get(k))).getname());
							coltypes.add(((MDField) (columns.get(k)))
									.getdatatype());
							colwidths.add(((MDField) (columns.get(k)))
									.getWidth());
							colprecis.add(((MDField) (columns.get(k)))
									.getPrecision());
						}
					}
				}
				System.out.println("colnames:" + colnames.size());

				varDN = (Vector) arDN.get(i + 1);

				dr = (DataResource) varDN.get(0);

				DeliverFromDT deliverFromDT = new DeliverFromDT();
				deliverFromDT.setDataTransportInput(outputStream
						.getDataTransport());
				deliverFromDT.setDataTransportMode(DataTransportMode.BLOCK);
				ActivityRequest sinkrequest = new ActivityRequest();
				sinkrequest.add(deliverFromDT);

				dropTable = "drop table if exists uploadName";
				drop = new SQLUpdate(dropTable);
				sinkrequest.add(drop);

				// create table and bulkload
				String createTable = "create table if not exists uploadName (";
				for (int j = 0; j < colnames.size(); j++) {
					if (j == 0)
						createTable += (String) cn.get(j) + " "
								+ (String) coltypes.get(j) + "("
								+ (String) colwidths.get(j) + ","
								+ (String) colprecis.get(j) + ")";
					else
						createTable += "," + (String) cn.get(j) + " "
								+ (String) coltypes.get(j) + "("
								+ (String) colwidths.get(j) + ","
								+ (String) colprecis.get(j) + ")";
				}
				createTable += ")";

				SQLUpdate create = new SQLUpdate(createTable);
				SQLBulkLoad bulkLoad = new SQLBulkLoad(deliverFromDT
						.getOutput(), "uploadName");

				sinkrequest.add(create);
				sinkrequest.add(bulkLoad);

				response = dr.perform(sinkrequest);
				this.session = response.getSession();

			}
		}
	}

	public int getARDNCount() {
		return arDN.size();
	}

	public Vector getColumns(String Alias) {
		int ialias = vvAlias.indexOf(Alias);
		Vector v = new Vector();
		// System.out.println(ialias);
		if (ialias == -1)
			return v;
		else {
			v = (Vector) (vvColumns.get(ialias));
			return v;
		}
	}

	public String getTableName(DBObject Alias) {
		// System.out.println(vAlias.indexOf(Alias));
		// System.out.println(((DBObject)vDBObject.get(0)).getADQLString());
		String TableName = ((DBObject) vDBObject.get(vAlias.indexOf(Alias)))
				.getADQLString();

		return TableName;
	}

	public Session getSession() {
		return this.session;
	}

	public void setTargetURL(String targetURL) {
		this.targetURL = new String(targetURL);
	}

	public void setFormat(int format) {
		this.format = format;
	}

	public String getQueryResult() {
		return this.queryresult;
	}
	/**
	 * @param args
	 */
	// public static void main(String[] args) {
	// // TODO Auto-generated method stub
	// ExecPlan ep = new ExecPlan();
	// try{
	// ep.execFrom();
	// ep.execSelect();
	// // ep.execWhere();
	// }catch(Exception e){
	// e.getStackTrace();
	// }
	//      
	// }
	/**
	 * for test only, by LC 2007-10-29
	 */
	
	static public void main(String[] args){
		try{
			ADQLParser adql=new ADQLParser();
			//String adqlstr="select o.ra, o.decl from Archive:ppParams o where o.flag='nnnn' and o.feha>-9 and o.feha<-3";
			String adqlstr="select s.ra,s.decl,o.path,o.ra, o.dec from , SDSS:Star2 s, SpecTest:DR6spSpec o where XMATCH(o,s,0.1) and region('circle J2000 1 22 0.7') and o.dec>-9 and o.dec<-3";
			//String adqlstr="select ss.ra  from SpecTest:DR6spSpecOrg ss where  region('circle J2000 1 22 0.7')";
			SelectStatement ss=adql.parse(adqlstr);
			RegistryProxy rp=new RegistryProxy();
			 DataResourceMap drm=DataResourceMap.getInstance();
			rp.discover(drm);
			ExecPlan execplan = new ExecPlan(ss);	
		}
		catch(Exception e){
			System.out.println(e.getMessage());
			
		}
	}
}