/**
 * 
 */
package org.china.vo.das.service;

/**
 * 
 */


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Properties;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 * @author Haijun 04142008
 * 
 */
public class ServerConfigure {

	private String servername = null;

	private String serverdescription = null;

	private String registryurl = null;

	private String workthreadnum = null;

	private String jobvalidperiod = null;
	
	private String discoverperiod = null;

	private String vostorageurl = null;
	
	private String sessionidleperiod = null;

	/**
	 * @return the jobvalidperiod
	 */
	public String getJobvalidperiod() {
		return jobvalidperiod;
	}

	/**
	 * @param jobvalidperiod
	 *            the jobvalidperiod to set
	 */
	public void setJobvalidperiod(String jobvalidperiod) {
		this.jobvalidperiod = jobvalidperiod;
	}
	
	
	/**
	 * @return the sessionidleperiod
	 */
	public String getSessionidleperiod() {
		return sessionidleperiod;
	}

	/**
	 * @param sessionidleperiod the sessionidleperiod to set
	 */
	public void setSessionidleperiod(String sessionidleperiod) {
		this.sessionidleperiod = sessionidleperiod;
	}

	/**
	 * @return the registryurl
	 */
	public String getRegistryurl() {
		return registryurl;
	}

	/**
	 * @param registryurl
	 *            the registryurl to set
	 */
	public void setRegistryurl(String registryurl) {
		this.registryurl = registryurl;
	}

	/**
	 * @return the serverdescription
	 */
	public String getServerdescription() {
		return serverdescription;
	}

	/**
	 * @param serverdescription
	 *            the serverdescription to set
	 */
	public void setServerdescription(String serverdescription) {
		this.serverdescription = serverdescription;
	}

	/**
	 * @return the servername
	 */
	public String getServername() {
		return servername;
	}

	/**
	 * @param servername
	 *            the servername to set
	 */
	public void setServername(String servername) {
		this.servername = servername;
	}

	/**
	 * @return the vostorageurl
	 */
	public String getVostorageurl() {
		return vostorageurl;
	}

	/**
	 * @param vostorageurl
	 *            the vostorageurl to set
	 */
	public void setVostorageurl(String vostorageurl) {
		this.vostorageurl = vostorageurl;
	}

	/**
	 * @return the workthreadnum
	 */
	public String getWorkthreadnum() {
		return workthreadnum;
	}

	/**
	 * @param workthreadnum
	 *            the workthreadnum to set
	 */
	public void setWorkthreadnum(String workthreadnum) {
		this.workthreadnum = workthreadnum;
	}

	public void parseConfigureFile(String filepath) throws IOException,
			SAXException, ParserConfigurationException {

		org.w3c.dom.Document document;
		javax.xml.parsers.DocumentBuilderFactory dbf = DocumentBuilderFactory
				.newInstance();
		dbf.setValidating(false);
		javax.xml.parsers.DocumentBuilder parser = dbf.newDocumentBuilder();
		parser.setErrorHandler(new org.xml.sax.ErrorHandler() {
			public void warning(SAXParseException e) {
				System.err.println("WARNING: " + e.getMessage());
			}

			public void error(SAXParseException e) {
				System.err.println("ERROR: " + e.getMessage());
			}

			public void fatalError(SAXParseException e) throws SAXException {
				System.err.println("FATAL: " + e.getMessage());
				throw e; // re-throw the error
			}
		});

		document = parser.parse(filepath);
		NodeList servernode = document.getElementsByTagName("Server");
		Element dbrTag = (Element) servernode.item(0);
		this.setServername(getNodeValue(dbrTag, "ServerName"));
		this.setServerdescription(getNodeValue(dbrTag, "ServerDescription"));
		this.setRegistryurl(getNodeValue(dbrTag, "RegistryURL"));
		this.setWorkthreadnum(getNodeValue(dbrTag, "WorkThreadNum"));
		this.setJobvalidperiod(getNodeValue(dbrTag, "JobValidPeriod"));
		this.setSessionidleperiod(getNodeValue(dbrTag, "SessionIdlePeriod"));
		this.setDiscoverperiod(getNodeValue(dbrTag, "DiscoverPeriod"));
		this.setVostorageurl(getNodeValue(dbrTag, "VOStorageURL"));

	}

	public String getFilePath(){
		
		String filepath=null;
		try {
			Properties ps = getEnv();
			filepath = ps.getProperty("CATALINA_HOME");
			filepath = filepath.replace("'", "");
			   String OS = System.getProperty("os.name").toLowerCase();   
			   if (OS.indexOf("windows") > -1)  
			   {  
			      filepath = filepath + "\\das\\server.xml";
			   }  
			   else if(OS.indexOf("linux") > -1)  
			          {  
			    	filepath = filepath + "/das/server.xml";
			          } 
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return filepath;
	}
	
	
	  // صǰϵͳĺһPropertiesߣֻwin2kϵģϵͳԼĽ  
	  public Properties getEnv() throws Exception  
	  {  
	   Properties prop = new Properties();  
	   String OS = System.getProperty("os.name").toLowerCase();  
	 //  System.out.println("ϵͳ:" + OS);  
	   Process p = null;  
	   if (OS.indexOf("windows") > -1)  
	   {  
	    p = Runtime.getRuntime().exec("cmd /c set");  
	   }  
	    if(OS.indexOf("linux") > -1)  
	          {  
	             p = Runtime.getRuntime().exec("sh -c set");  
	          }  
	   BufferedReader br = new BufferedReader(new InputStreamReader(p.getInputStream()));  
	   String line;  
	   while ((line = br.readLine()) != null)  
	   {  
	    int i = line.indexOf("=");  
	    if (i > -1)  
	    {  
	     String key = line.substring(0, i);  
	     String value = line.substring(i + 1);  
	     prop.setProperty(key, value);  
	    }  
	   }  
	   return prop;  
	  }  
	
	public String getNodeValue(Element bigTag, String nodeName)
			throws NullPointerException {

		// if (bigTag.getElementsByTagName(nodeName) == null) {
		// System.out.println("nodename error!");
		// return "NOT PROVIDED";
		// }

		try {
			Node aTag2 = bigTag.getElementsByTagName(nodeName).item(0);
			if (aTag2.getFirstChild() == null) {
				System.out.println("Found node like <**></**>");
				return "NOT PROVIDED";
			}
			String tagName = ((Element) aTag2).getTagName();
			if (tagName.equals("Subject") || tagName.equals("Instrument")
					|| tagName.equals("ContentLevel")
					|| tagName.equals("CoverageSpectral")) {
				NodeList stringList = ((Element) aTag2)
						.getElementsByTagName("string");
				int stringNum = stringList.getLength();
				String strings = "";
				// if (stringNum == 0) {
				//
				// return "NOT PROVIDED";
				// }
				for (int i = 0; i < stringNum; i++) {
					if (stringList.item(i).getFirstChild() == null) {
						System.out
								.println("Found node like <ContentLevel>\n<string/>\n</ContentLevel>");
						strings += "NOT PROVIDED" + "\n";
					} else {
						strings += ((Text) (stringList.item(i).getFirstChild()))
								.getData().trim()
								+ "\n";
					}
				}
				return stringNum + "\t" + strings;
			} else {

				String tagvalue2 = ((Text) aTag2.getFirstChild()).getData()
						.trim();
				return tagvalue2;
			}
		} catch (NullPointerException e) {
			System.out.println("The nodename is not supported!");
			return "NOT PROVIDED";
		}

	}

	/**
	 * @return the discoverperiod
	 */
	public String getDiscoverperiod() {
		return discoverperiod;
	}

	/**
	 * @param discoverperiod the discoverperiod to set
	 */
	public void setDiscoverperiod(String discoverperiod) {
		this.discoverperiod = discoverperiod;
	}

	/**
	 * @param args
	 */
/*
	public static void main(String[] args) {
		
		ServerConfigure sc= new ServerConfigure();
		String filepath = getFilePath() + "\\das\\server.xml";
		System.out.println(filepath);
		try {
			sc.parseConfigureFile(filepath);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println("RegistryURL is:"+ sc.getRegistryurl());
		

	}
*/
}

